#include "stdafx.h"
#include "CGEnemy.h"
#include "CGame.h"

extern CGame game;

static int g_g_c[10];

void CGEnemy::CollapseGroundSmall(){
	game.CreateObject(LIST_EXP_,EXPROSE_GROUND_EXP_,fvPosition);
}

void CGEnemy::CollapseGroundBig(){
	game.CreateObject(LIST_EXP_,BIG_GROUND_EXP_,fvPosition);
}

void CGEnemy::SetDataToDefault(){
	bHittable=false;
	Data.nTurn=0;
	Data.fAccel=GEnemyData.fAccel;//Wx

    fRadiation=GEnemyData.fRadiation;

	fSpeed=GEnemyData.fSpeedSlow;
	if(nEnemyType==E_DAMAGED_TANK_)fSpeed=0;
	Data.fScore=GEnemyData.fScore;
	Data.fHP=GEnemyData.fHP;
	Data.fShotAngle=0;
	Data.fShotAngleStep=0;
	Data.fShotInterval=1;

}

/***************************
	Common setting
***************************/
void CGEnemy::CommonInitGEnemy(int type){
	CommonInitEnemy(type);
	nEnemyType=type;
//	eBitsList.clear();

	SetDataToDefault();

	//SetDataToDafault()Ή΍
	float r=GEnemyData.fRadiation;

	float speed=GEnemyData.fSpeedSlow;
	float score=GEnemyData.fScore;
	float hp=GEnemyData.fHP;
	CozyRect src;

	switch(type){
	//n
	case E_TANK_://E_TANK_X_:E_TANK_Y_:
    	Tank(0);
        break;
	case E_DAMAGED_TANK_://E_DAMAGED_TANK_X_:E_DAMAGED_TANK_Y_:
    	DamagedTank(0);
      break;
	case E_UNMOVABLE_TANK_:
		UnmovableTank(0);
		break;
	case E_RUN_AND_STOP_TANK_:
    	RunAndStopTank(0);
		break;
	case E_CRAB_TANK_:
    	CrabTank(0);
        break;
	case E_GATRING_:
		Gatring(0);
		break;
	case E_GATRING_B_:
		GatringB(0);
        break;
	case E_BORT_://E_BORT_X_:E_BORT_Y_:
 		src=GEnemyData.Boat.frSrcRect;
		hp*=GEnemyData.Boat.fHPDiv;
		score*=GEnemyData.Boat.fScoreDiv;

		Data.fShotInterval=GEnemyData.Boat.fShotInterval;
      break;
    case E_W_TANK_:
    	WTank(0);
        break;

	case E_LITTLE_BOX_:
  		src=GEnemyData.LittleBox.frSrcRect;
		hp*=GEnemyData.LittleBox.fHPDiv;
		score*=GEnemyData.LittleBox.fScoreDiv;

        Data.fShotInterval=GEnemyData.nLittleBoxShotInterval;
        Data.fShotIntervalMax=GEnemyData.nLittleBoxFirstWait;
        Data.fShotAngle=DegreeToRadian(GEnemyData.fLittleBoxShotError);
        break;

	case E_S_CANNON_:
        break;
	case E_M_CANNON_:
  		src=GEnemyData.MCannon.frSrcRect;
		hp*=GEnemyData.MCannon.fHPDiv;
		score*=GEnemyData.MCannon.fScoreDiv;

        Data.fShotInterval=GEnemyData.nMCannonShotStart;
        Data.fShotIntervalMax=GEnemyData.nMCannonShotStart+
        	GEnemyData.nMCannonShotTime;
		speed=0;

       	break;
    case E_L_CANNON_:
 		src=GEnemyData.LCannon.frSrcRect;
		hp*=GEnemyData.LCannon.fHPDiv;
		score*=GEnemyData.LCannon.fScoreDiv;

		speed=0;
		Data.fShotInterval=GEnemyData.LCannon.fShotInterval;
		Data.fShotAngleStep=DegreeToRadian(GEnemyData.fLCannonShotAngleStep);
		r+=10;
		Data.fShotAngle=0;
        break;

	case E_HIDE_CANNON_:
  		src=GEnemyData.HideCannon.frSrcRect;
		hp*=GEnemyData.HideCannon.fHPDiv;
		score*=GEnemyData.HideCannon.fScoreDiv;

		Data.fShotInterval=GEnemyData.HideCannon.fShotInterval
        	*3.f/GameData.nLevel;
        Data.animeID=CAnime(GEnemyData.nHideCannonIDMax,
        	GEnemyData.fHideCannonFrameWait,ONLY_ONE_ANIME_);
        speed=0;
        break;
	case E_S_LAUNCHER_:
  		src=GEnemyData.MissileLauncher.frSrcRect;
		hp*=GEnemyData.MissileLauncher.fHPDiv;
		score*=GEnemyData.MissileLauncher.fScoreDiv;

		speed=0;
        Data.fShotInterval=GEnemyData.MissileLauncher.fShotInterval;
    	Data.fShotAngle=DegreeToRadian(GEnemyData.fMissileLauncherShotErrorDeg);
        break;

    case E_GUNBORT_:case E_GUNBORT_DESTROYED_:
  		src=GEnemyData.GunBoat.frSrcRect;
		hp*=GEnemyData.GunBoat.fHPDiv;
		score*=GEnemyData.GunBoat.fScoreDiv;

		if(type==E_GUNBORT_){
			Data.fShotIntervalMax=GEnemyData.fGunBoatMainShotWait;
			Data.fShotInterval=GEnemyData.fGunBoatSubShotInterval;
		}else{
			Data.fShotInterval=GEnemyData.fGunBortDestroyedShotInterval;
		}
		break;
    case E_TRAIN_GUARD_: //ړ
  		src=GEnemyData.VTrainGuard.frSrcRect;
		hp*=GEnemyData.VTrainGuard.fHPDiv;
		score*=GEnemyData.VTrainGuard.fScoreDiv;

		Data.fShotInterval=
			GEnemyData.VTrainGuard.fShotInterval/GameData.nLevel;
		r+=10;
		break;

	case E_TRAIN_GUNNER_SPACE_:   //c
	case E_TRAIN_GUNNER_:
		//ˎ
		Data.fShotIntervalMax=GEnemyData.fTrainGunnerTimeToStopShot*
			GameData.nLevel;
		Data.fShotInterval=GEnemyData.TrainGunner.fShotInterval;

 		src=GEnemyData.TrainGunner.frSrcRect;
		hp*=GEnemyData.TrainGunner.fHPDiv;
		score*=GEnemyData.TrainGunner.fScoreDiv;

		if(type==E_TRAIN_GUNNER_SPACE_){
			src.fX+=64;
		}
		break;

    //^n
    case E_G_MOUNTAIN_01_:
 		src=GEnemyData.Mountain.frSrcRect;
		hp*=GEnemyData.Mountain.fHPDiv;
		score*=GEnemyData.Mountain.fScoreDiv;

		//͂߂͒~
		speed=0;
		r+=15;
        break;
	case E_G_MOUNTAIN_02_:  //^
		Mountain2(0);
		break;
	case E_PUMP_02_:
		Pumpkin2(0);
    	break;
   //{X
     //1ʃ{X
    case E_PUMP_01_: //
    case E_PUMP_03_: //
    case E_BOSS_01_: //m[}J{`
    case E_BOSS_02_: //\J{`
    case E_BOSS_03_:
    case E_BOSS_04_:
 		src=GEnemyData.Pumpkin.frSrcRect;
		hp*=GEnemyData.Pumpkin.fHPDiv;
		score*=GEnemyData.Pumpkin.fScoreDiv;

		//͂߂͒~
		speed=0;
		Data.fShotAngleStep=DegreeToRadian(GEnemyData.PumpkinShotAngleAccel);
		fvDirection=nullVector2;

		if(nEnemyType>=E_BOSS_01_ && nEnemyType<=E_BOSS_04_){
			hp*=GEnemyData.DivHPToBossFromPumpkin;
			score*=GEnemyData.DivScoreToBossFromPumpkin;
		}

		Data.fShotAngle=DegreeToRadian(90);

		r+=15;
		if(nEnemyType==E_BOSS_02_){
			Data.fShotIntervalMax=20.f/GameData.nLevel;
			Data.fShotInterval=DegreeToRadian(90);
		}else{
			Data.fShotInterval=DegreeToRadian(1);
			Data.fShotIntervalMax=Data.fShotInterval;
		}
        break;

    case E_DRAGON_01_:case E_DRAGON_02_:      //4ʃ{X

    case E_HOVER_01_:case E_HOVER_02_:case E_HOVER_03_:    //5ʃzo[

    case E_MONSTAR_01_:
		Monster1(0);
		break;
	case E_MONSTAR_02_:    //6ʕ
		Monster2(0);
		break;

    case E_GATE_01_:case E_GATE_02_:case E_GATE_03_:case E_GATE_04_:
		break;
	}

	if(type!=E_TANK_ && type!=E_DAMAGED_TANK_ &&
    	type!=E_RUN_AND_STOP_TANK_ && type!=E_UNMOVABLE_TANK_ &&
        type!=E_CRAB_TANK_ && type!=E_W_TANK_ && type!=E_GATRING_ &&
		type!=E_GATRING_B_ && type!=E_MONSTAR_01_ && type!=E_MONSTAR_02_ &&
		type!=E_PUMP_02_ && type!=E_G_MOUNTAIN_02_){
    	fSpeed=speed;
		Data.fScore=score;
		Data.fHP=hp;
		frSrcRect=src;
		fRadiation=r;
	}
	Data.fHPMax=Data.fHP;
    if(Data.fShotInterval==0){
    	Data.fShotInterval=1;
    }
}

CGEnemy::CGEnemy(int type,Vector2<float> pos0,Vector2<float> dir0)
:CEnemy(type,pos0,dir0){
	CommonInitGEnemy(type);
}

/***************************
	
***************************/
int CGEnemy::Move(Vector2<float> target_pos,float scroll_speed){
	BasicMove();
	if(nEnemyType!=E_MONSTAR_01_ && nEnemyType!=E_MONSTAR_02_){
		fvPosition.fY+=scroll_speed;
	}

	Data.nCounter++;

	Vector2<float> aim=Vector2<float>(target_pos.fX-fvPosition.fX,
		target_pos.fY-fvPosition.fY);
	int reply=0;
	Vector2<float> shot_pos,shot_dir;

	int a;

	switch(nEnemyType){
	case E_TANK_:
    	reply=Tank(1,0,target_pos);
    	break;
	case E_UNMOVABLE_TANK_:
    	reply=UnmovableTank(1,0,target_pos);
        break;
	case E_RUN_AND_STOP_TANK_:
    	reply=RunAndStopTank(1,0,target_pos);
		break;
	case E_DAMAGED_TANK_:
    	reply=DamagedTank(1,0,target_pos);
		break;
	case E_CRAB_TANK_:
    	reply=CrabTank(1,0,target_pos);
		break;
	case E_GATRING_:
		reply=Gatring(1,0,target_pos);
		break;
	case E_GATRING_B_:
		reply=GatringB(1,0,target_pos);
		break;
	case E_BORT_:
		//ɂă\[X߂
		frSrcRect.fX=GEnemyData.Boat.frSrcRect.fX+
			fvDirection.ChangeDirectionN(4)*frSrcRect.fWidth;

		//Œe
		if(Data.nCounter%(int)Data.fShotInterval==0){
			Data.nTurn++;
			if(Data.nTurn%2==0)
				reply=1;
			else
				reply=2;
		}
		break;
	case E_W_TANK_:
    	reply=WTank(1,0,target_pos);
		break;
    case E_G_MOUNTAIN_01_:
		//ړp[g
		// 0|~|c[0]||c[1]
		g_g_c[0]=20;
		g_g_c[1]=g_g_c[0]+15;
		if(g_g_c[0]<(Data.nCounter%g_g_c[1]) && g_g_c[1]>(Data.nCounter%g_g_c[2])){
			fSpeed=GEnemyData.fSpeedSlow;//*scroll_speed;
		}else fSpeed=0;

		//˃p[g{n}replyɑĕԂl
		// 0|Ȃ|c[2]˕|{1}(c[3]Ԋu)|c[-]({1}I)|
		//		{2}|c[4]{3}|c[5]{3}
		g_g_c[2]=10;
		g_g_c[3]=2;
		g_g_c[4]=g_g_c[2]+60;
		g_g_c[5]=g_g_c[4]+10;
		g_g_c[6]=3;
		if(Data.nCounter<g_g_c[2]){
			//Ȃ
			;
		}else if(Data.nCounter==g_g_c[2]){
			//ݒ
			Data.fShotAngle=0;
			Data.fShotAngleStep=DegreeToRadian(90/2/GameData.nLevel);
			reply=1;
		}else if(Data.nCounter>g_g_c[2] && Data.fShotAngle<DegreeToRadian(90)){
			if(Data.nCounter%g_g_c[3]==0){
				Data.fShotAngle+=Data.fShotAngleStep;
				reply=1;
			}
		}else if(Data.nCounter<g_g_c[4] && Data.nCounter%g_g_c[6]==0){
			reply=2;
		}else if(Data.nCounter==g_g_c[4]){
			reply=3;
		}else if(Data.nCounter==g_g_c[5]){
			reply=3;
			Data.nCounter=0;
		}
		break;
	case E_G_MOUNTAIN_02_:  //^
		reply=Mountain2(1,0,target_pos);
		break;
	case E_PUMP_01_: //
		//˕]
		Data.fShotAngle+=Data.fShotAngleStep;
		if(Data.fShotAngle>DegreeToRadian(360))Data.fShotAngle-=DegreeToRadian(360);
		if(Data.fShotAngle<0)Data.fShotAngle+=DegreeToRadian(360);
		g_g_c[0]=50;//x̕ω
		g_g_c[1]=7;//x̉{ɂȂt邩
		g_g_c[2]=5;//ˊԊu
		if(Data.nTurn==0){
			//]x̉A
			Data.fShotAngleStep-=fabs(DegreeToRadian(GEnemyData.PumpkinShotAngleAccel)/g_g_c[0]);

			//ȏɂȂt]
			if(Data.fShotAngleStep<-DegreeToRadian(GEnemyData.PumpkinShotAngleAccel)*(float)g_g_c[1]){
				Data.nTurn=1;
			}
		}else{
			Data.fShotAngleStep-=fabs(DegreeToRadian(GEnemyData.PumpkinShotAngleAccel)/g_g_c[0]);

			//ȏɂȂt]
			if(Data.fShotAngleStep>DegreeToRadian(GEnemyData.PumpkinShotAngleAccel)*(float)g_g_c[1]){
				Data.nTurn=0;
			}
		}

		//ԊuŔ
		if(Data.nCounter%g_g_c[2]==0){
			reply=1;
		}
		break;
	case E_PUMP_02_:
		reply=Pumpkin2(1,0,target_pos);
    	break;
	case E_PUMP_03_:
    	//głVbg
        if(Data.nTurn==0){
        	Data.fShotAngle+=Data.fShotAngleStep;
        }else{
        	Data.fShotAngle-=Data.fShotAngleStep;
        }

        if(fabs(aim.VectorToAngle-Data.fShotAngle)>
        		DegreeToRadian(GEnemyData.fPumpkinShotErrorMax)){
        	//s߂߂ċt֐iނ悤ɂ
	        Data.fShotAngle+=Data.fShotAngleStep;
            Data.nTurn=(Data.nTurn==0)?1:0;
        }
        break;
	case E_BOSS_01_: //m[}J{`
		//c[1]߂炻yWɂƂǂ܂悤ɂ
		g_g_c[1]=(int)(200.f/scroll_speed);
		if(Data.nCounter==g_g_c[1]){
			fSpeed=GEnemyData.fSpeedSlow;
			fvDirection.SetVector(1,0);
		}else if(Data.nCounter>g_g_c[1]){
			fvPosition.fY-=scroll_speed;
			//c[0]Ƃɒe
			g_g_c[0]=20/GameData.nLevel;
			if(Data.nCounter%g_g_c[0]==0){
				reply=1;
			}
			fSpeed+=Data.fAccel;
			if(fSpeed>GEnemyData.fSpeedSlow)fSpeed=GEnemyData.fSpeedSlow;
			if(fSpeed<-GEnemyData.fSpeedSlow)fSpeed=-GEnemyData.fSpeedSlow;

			g_g_c[0]=100;
			if(/*fSpeed<GEnemyData.fAccel &&*/
					fvPosition.fX<GameData.frStageRange.fX+g_g_c[0] ){
				if(fSpeed<GEnemyData.fSpeedSlow)Data.fAccel+=0.05f;
			}
			if(fvPosition.fX>GameData.frStageRange.fX+GameData.frStageRange.fWidth-g_g_c[0]
					/*&&fSpeed>GEnemyData.fAccel*/){
				if(-fSpeed<GEnemyData.fSpeedSlow)Data.fAccel-=0.05f;
			}
		}
		break;
	case E_BOSS_02_: //\J{`
		//c[1]߂炻̈ʒuɂƂǂ܂悤ɂ
		g_g_c[1]=(int)(50.f/scroll_speed);
		if(Data.nCounter>g_g_c[1]){
			fvPosition.fY-=scroll_speed;

			Data.fShotAngle+=Data.fShotAngleStep;
			if(Data.fShotAngle>DegreeToRadian(360)){
				Data.fShotAngle-=DegreeToRadian(360);
			}
			Data.fShotInterval+=Data.fShotAngleStep/2.f;
			if(Data.fShotInterval>DegreeToRadian(360)){
				Data.fShotInterval-=DegreeToRadian(360);
			}

			//c̗͂3؂Ɣ
			if(Data.fHP<100*GEnemyData.Pumpkin.fHPDiv*
				GEnemyData.DivHPToBossFromPumpkin/3 && Data.nTurn==0){
				Data.nTurn=1;
				Data.fShotIntervalMax/=2;
			}

			//fShotIntervalƂɒe

			if(Data.nCounter%(int)Data.fShotIntervalMax==0){
				reply=1;
			}
			if(Data.nCounter%(int)(Data.fShotIntervalMax*10)==0){
				reply=2;
			}
		}else fSpeed=0;
		break;
	case E_BOSS_03_:
	case E_BOSS_04_:
		break;
	case E_L_CANNON_:
		//Change source by direction
		frSrcRect.fX=GEnemyData.LCannon.frSrcRect.fX+
			frSrcRect.fWidth*((fvDirection.ChangeDirectionN(8)+2)%8);

		//aim to target
		fvDirection.GraduateHomingAim(aim,
			DegreeToRadian(GEnemyData.fLCannonTurnSpeed));
		//fvDirection.DirectHomingAim(aim);

		Data.fShotAngle+=Data.fShotAngleStep;//+=DegreeToRadian(GEnemyData.fLCannonTurnSpeed*10);
		if(fabs(Data.fShotAngle)>DegreeToRadian(30)){
			Data.fShotAngleStep*=-1;
			Data.fShotAngle+=Data.fShotAngleStep;
		}
		if(Data.nCounter%(int)Data.fShotInterval==0){
			reply=1;
		}
		break;
	case E_TRAIN_GUARD_:
		if(Data.nCounter%(int)(Data.fShotInterval)==0){
			reply=1;
		}
		break;
	case E_TRAIN_GUNNER_:
		if(Data.nTurn==0 && Data.nCounter==GEnemyData.fTrainGunnerWaitTime){
			Data.nTurn=1;
			fSpeed=0;
			reply=1;
		}
		if(Data.nTurn==1 && Data.nCounter==GEnemyData.fTrainGunnerWaitTime+
				Data.fShotIntervalMax){
			Data.nTurn=0;
			fSpeed=GEnemyData.fSpeedSlow;
			Data.nCounter=0;
		}
		break;
	case E_TRAIN_GUNNER_SPACE_:
		if(Data.nTurn==0 && Data.nCounter==GEnemyData.fTrainGunnerWaitTime){
			Data.nTurn=1;
			fSpeed=0;
			Data.fAccel=0.5;//x
		}
		if(Data.nTurn==1){
			if(Data.nCounter%(int)(Data.fShotInterval)==0){
				reply=1;
				Data.fAccel+=0.1f;
			}
			if(Data.nCounter==GEnemyData.fTrainGunnerWaitTime+
				Data.fShotIntervalMax){
				Data.nTurn=0;
				fSpeed=GEnemyData.fSpeedSlow;
				Data.nCounter=0;
			}
		}
		break;
	case E_GUNBORT_:
		if(Data.nCounter==Data.fShotIntervalMax){
			//CVbgˁI
			reply=1;
		}else if(Data.nCounter>=Data.fShotIntervalMax &&
			Data.nCounter%(int)(Data.fShotInterval)==0){
			//TuVbgˁI
			reply=2;
		}
		break;
	case E_GUNBORT_DESTROYED_:
		if(Data.nCounter%(int)(Data.fShotInterval)==0){
			reply=1;
		}
		break;
    case E_M_CANNON_:
  		//Change source by direction
		frSrcRect.fX=GEnemyData.MCannon.frSrcRect.fX+
			frSrcRect.fWidth*((aim.ChangeDirectionN(8)+2)%8);

        if(Data.nCounter>Data.fShotInterval &&
				Data.nCounter<Data.fShotIntervalMax){
            //if(Data.nCounter%(int)(GEnemyData.fMCannonShotInterval)==0){
				reply=1;
			//}
        }else if(Data.nCounter==Data.fShotIntervalMax){
        	//~߁Bȉl
            Data.nCounter=0;
        }
		break;
    case E_HIDE_CANNON_:
		if(Data.nCounter>GEnemyData.nHideCannonWaitTime){
			a=Data.animeID.Execute();
			if(Data.animeID.GetID()!=0){
				frSrcRect.fY=32;
			}
			frSrcRect.fX=GEnemyData.HideCannon.frSrcRect.fX+
				frSrcRect.fWidth*Data.animeID.GetID();

			if(a){
				//Aj[VI
			    //e𔭎
			    if(Data.nCounter%(int)(Data.fShotInterval)==0){
			        reply=1;
			    }
			}
		}
    	break;
    case E_S_LAUNCHER_:
		//ɂă\[X߂
		frSrcRect.fX=GEnemyData.MissileLauncher.frSrcRect.fX+
			((aim.ChangeDirectionN(8)+2)%8)*frSrcRect.fWidth;

    	if(Data.nCounter%(int)(Data.fShotInterval)==0){
        	reply=1;
        }
    	break;
    case E_LITTLE_BOX_:
       	if(Data.nCounter>=Data.fShotIntervalMax){
			fSpeed=GEnemyData.fSpeedSlow;
        	if(Data.nCounter%(int)(Data.fShotInterval)==0){
            	reply=1;
            }
            if(Data.nCounter==Data.fShotIntervalMax+
            	Data.fShotInterval*GEnemyData.nLittleBoxShotNum){
                fSpeed=0;
				if(Data.nTurn==0){
                	Data.nTurn=1;
                    Data.fShotIntervalMax=GEnemyData.nLittleBoxNextWait;
                }
                Data.nCounter=0;
            }
        }
    	break;
	case E_MONSTAR_01_:
		reply=Monster1(1,0,target_pos);
		break;
	case E_MONSTAR_02_:
		reply=Monster2(1,0,target_pos);
		break;

	}
	if(!CheckSeekable())bAlive=false;
	return reply;
}

/***************************
	
***************************/
void CGEnemy::Shot(Vector2<float> target_pos,int command)
{
	Vector2<float> aim=Vector2<float>(target_pos.fX-fvPosition.fX,
		target_pos.fY-fvPosition.fY);
	Vector2<float> shot_pos,shot_dir;

	int n,i,j,m;//,type;

	if(command!=0){
		switch(nEnemyType){
		case E_TANK_:
        	Tank(2,command,target_pos);
            break;
		case E_UNMOVABLE_TANK_:
        	UnmovableTank(2,command,target_pos);
		case E_RUN_AND_STOP_TANK_:
        	RunAndStopTank(2,command,target_pos);
			break;
		case E_W_TANK_:
			WTank(2,command,target_pos);
			break;
	    case E_G_MOUNTAIN_01_://^
			if(command==1){
				//e
				shot_pos.SetVector(-22,-2);
				shot_pos.AddVector(fvPosition);
				shot_dir.AngleToVector(Data.fShotAngle);
				for(i=0;i<GameData.nLevel;i++){
					game.CreateObject(LIST_E_SHOT_,LARGE_SHOT_,
						shot_pos,shot_dir,1.0f/(i+1));
				}
				shot_pos.SetVector(20,-2);
				shot_pos.AddVector(fvPosition);
				shot_dir.AngleToVector(DegreeToRadian(180)-Data.fShotAngle);
				for(i=0;i<GameData.nLevel;i++){
					game.CreateObject(LIST_E_SHOT_,LARGE_SHOT_,
						shot_pos,shot_dir,1.0f/(i+1));
				}
			}else if(command==2){
				for(i=-1;i<2;i+=2){
					shot_pos.SetVector(i*32*sin(DegreeToRadian(Data.nCounter*10)),5);
					shot_pos.AddVector(fvPosition);
					game.CreateObject(LIST_E_SHOT_,MIDIUM_SHOT_,
						shot_pos,Vector2<float>::GetVector(0.f,1.f));
				}
			}else if(command==3){
				//~TC
				n=2*GameData.nLevel+1;

				//
				shot_pos.SetVector(-22,-20);
				shot_pos.AddVector(fvPosition);
				CShot::NWayShot(n,fvPosition,DegreeToRadian(225),
					DegreeToRadian(30.f/GameData.nLevel),0,pos_array,dir_array);
				for(i=0;i<n;i++){
					game.CreateObject(LIST_SKY_ENEMY_,E_MISSILE_,
						shot_pos,dir_array[i]);
				}
				shot_pos.SetVector(20,-20);
				shot_pos.AddVector(fvPosition);
				CShot::NWayShot(n,fvPosition,DegreeToRadian(315),
					DegreeToRadian(30.f/GameData.nLevel),0,pos_array,dir_array);
				for(i=0;i<n;i++){
					game.CreateObject(LIST_SKY_ENEMY_,E_MISSILE_,
						shot_pos,dir_array[i]);
				}
			}
			break;
		case E_G_MOUNTAIN_02_:  //^
			Mountain2(2,command,target_pos);
			break;
		case E_PUMP_01_: //
			//nwaye
			n=2*GameData.nLevel+1;
			CShot::NWayShot(n,fvPosition,Data.fShotAngle,
				DegreeToRadian(90.f/n),0,pos_array,dir_array);
			for(i=0;i<n;i++){
				game.CreateObject(LIST_E_SHOT_,LARGE_SHOT_,
					fvPosition,dir_array[i],1.2f);
				dir_array[i].AngleToVector(dir_array[i].VectorToAngle()+DegreeToRadian(180));
				game.CreateObject(LIST_E_SHOT_,LARGE_SHOT_,
					fvPosition,dir_array[i],1.2f);

			}

			break;
		case E_PUMP_02_:
        	Pumpkin2(2,command,target_pos);
        	break;
		case E_PUMP_03_:
			game.CreateObject(LIST_E_SHOT_,LARGE_SHOT_,
				fvPosition,Vector2<float>::AngleToVector2(Data.fShotAngle));
        	break;
		case E_BOSS_01_: //m[}J{`
			n=rand()%(2*GameData.nLevel)+rand()%2;
			if(n==0)n=1;
			//n=3;
			CShot::NWayShot(n,fvPosition,aim.VectorToAngle(),
				DegreeToRadian(120.f/n),0,pos_array,dir_array);
			for(i=0;i<n;i++){
				game.CreateObject(LIST_E_SHOT_,LARGE_SHOT_,
					fvPosition,dir_array[i]);
			}
			break;
		case E_BOSS_02_: //\J{`
			if(command==1){
				//S~t
				for(i=0;i<4;i++){
					shot_dir.AngleToVector(Data.fShotAngle+i*DegreeToRadian(90));
					game.CreateObject(LIST_E_SHOT_,LARGE_SHOT_,
						fvPosition,shot_dir);

					shot_dir.AngleToVector(DegreeToRadian(360)-
						Data.fShotInterval+i*DegreeToRadian(90));
					game.CreateObject(LIST_E_SHOT_,MIDIUM_SHOT_S_,
						fvPosition,shot_dir);
				}
			}else if(command==2){
				game.CreateObject(LIST_E_SHOT_,DUAL_HUGE_SHOT_,
					fvPosition,aim);
			}
			break;
		case E_BOSS_03_:
		case E_BOSS_04_:
			break;
		case E_CRAB_TANK_:
			CrabTank(2,command,target_pos);
            break;
		case E_L_CANNON_:
			shot_pos.AngleToVector(DegreeToRadian(45)*(fvDirection.ChangeDirectionN(8)));
			shot_pos.Expand(30);
			shot_pos.AddVector(fvPosition);
			shot_dir.AngleToVector(fvDirection.VectorToAngle()-Data.fShotAngle);
			game.CreateObject(LIST_E_SHOT_,LARGE_SHOT_,shot_pos,shot_dir);
			shot_dir.AngleToVector(fvDirection.VectorToAngle()+Data.fShotAngle);
			game.CreateObject(LIST_E_SHOT_,LARGE_SHOT_,shot_pos,shot_dir);
			break;
		case E_TRAIN_GUARD_:
			//Starange 5 way
			n=2;
			for(j=0;j<2;j++){
				CShot::NWayShot(n,fvPosition,DegreeToRadian(90),
					DegreeToRadian(30.f),j*30.f+15.f,pos_array,dir_array);
				for(i=0;i<n;i++){
					game.CreateObject(LIST_E_SHOT_,LARGE_SHOT_,
						pos_array[i],dir_array[i]);
				}
			}
			game.CreateObject(LIST_E_SHOT_,LARGE_SHOT_,
				fvPosition,Vector2<float>::GetVector(0.f,1.f));
			break;
		case E_TRAIN_GUNNER_:
			game.CreateObject(LIST_E_SHOT_,DUAL_HUGE_SHOT_SHOOTER_,
				fvPosition,aim);
			break;
		case E_TRAIN_GUNNER_SPACE_:
			game.CreateObject(LIST_E_SHOT_,LARGE_SHOT_,
				fvPosition,aim,Data.fAccel);
			break;
		case E_GATRING_:
        	Gatring(2,command,target_pos);
			break;
		case E_GATRING_B_:
        	GatringB(2,command,target_pos);
			break;
		case E_GUNBORT_:
			if(command==1){
				//2way˂ŕǂ
				n=2;
				m=20;
				for(j=1;j<=m;j++){
					CShot::NWayShot(n,fvPosition,aim.VectorToAngle(),
						DegreeToRadian(40),0,pos_array,dir_array);
					for(i=0;i<n;i++){
						game.CreateObject(LIST_E_SHOT_,LARGE_SHOT_,
							fvPosition,dir_array[i],j/(m/1.5f));
					}
				}
			}else{
				//I3wayMissile
				n=3;
				CShot::NWayShot(n,fvPosition,aim.VectorToAngle(),
					DegreeToRadian(30),0,pos_array,dir_array);
				for(i=0;i<n;i++){
					game.CreateObject(LIST_SKY_ENEMY_,E_MISSILE_,
						fvPosition,dir_array[i]);
				}
			}
			break;
		case E_GUNBORT_DESTROYED_:
			//I5way
			n=5;
			CShot::NWayShot(n,fvPosition,aim.VectorToAngle(),
				DegreeToRadian(100.f/n),0,pos_array,dir_array);
			for(i=0;i<n;i++){
				game.CreateObject(LIST_E_SHOT_,LARGE_SHOT_,
					fvPosition,dir_array[i]);
			}
			break;
        case E_M_CANNON_:
        	//aim֕se𕽍sɌ
			n=2;
            CShot::ParallelShot(fvPosition,aim,n,0,
            	GEnemyData.fMCannonShotInterval,pos_array,dir_array);
			for(i=0;i<n;i++){
				game.CreateObject(LIST_E_SHOT_,MIDIUM_SHOT_,
					pos_array[i],dir_array[i],GameData.nLevel/3.f);
			}
        	break;
        case E_HIDE_CANNON_:
        	game.CreateObject(LIST_E_SHOT_,SMALL_SHOT_,
            	fvPosition,aim);
        	break;
        case E_S_LAUNCHER_:
        	shot_dir.AngleToVector(aim.VectorToAngle()+
            	RandomDegreeToRadian(0,
					RadianToDegree(2*Data.fShotAngle))-Data.fShotAngle);
            game.CreateObject(LIST_SKY_ENEMY_,E_MISSILE_,
            	fvPosition,shot_dir);
        	break;
        case E_LITTLE_BOX_:
        	shot_dir.AngleToVector(aim.VectorToAngle()+
            	RandomDegreeToRadian(0,
					RadianToDegree(2*Data.fShotAngle))-Data.fShotAngle);
            game.CreateObject(LIST_E_SHOT_,LARGE_SHOT_,
            	fvPosition,shot_dir);
        	break;
		case E_BORT_:
			n=GameData.nLevel+command;
			CShot::NWayShot(n,fvPosition,aim.VectorToAngle(),
				DegreeToRadian(60.f/n),0,pos_array,dir_array);
			for(i=0;i<n;i++){
				game.CreateObject(LIST_E_SHOT_,MIDIUM_SHOT_S_,
					fvPosition,dir_array[i]);
			}
			break;
		case E_MONSTAR_01_:
			Monster1(2,0,target_pos);
			break;
		case E_MONSTAR_02_:
			Monster2(2,0,target_pos);
			break;
		}
	}
}

/***************************
	
***************************/
void CGEnemy::Collapse(void){
	bAlive=false;
	AddScore();

	switch(nEnemyType){
	case E_TANK_:
    	Tank(4);
    	break;
	case E_UNMOVABLE_TANK_:
	case E_RUN_AND_STOP_TANK_:
		game.CreateObject(LIST_EXP_,EXPROSE_GROUND_EXP_,fvPosition);
		game.CreateObject(LIST_G_ENEMY_,E_DAMAGED_TANK_,fvPosition,
			fvDirection);
		break;
	case E_BOSS_01_:
		game.CreateObject(LIST_EXP_,EXPROSE_GROUND_EXP_,fvPosition);
		game.CreateObject(LIST_G_ENEMY_,E_BOSS_02_,fvPosition,
			fvDirection);
		break;
	case E_BOSS_02_:
		game.CreateObject(LIST_EXP_,BOSS_EXP_,fvPosition);
		break;
	case E_W_TANK_:
	case E_TRAIN_GUARD_:
	case E_L_CANNON_:
	case E_G_MOUNTAIN_01_:case E_G_MOUNTAIN_02_:
	case E_PUMP_01_:
	case E_PUMP_02_:
	case E_PUMP_03_:
	case E_TRAIN_GUNNER_SPACE_:
	case E_TRAIN_GUNNER_:
	case E_MONSTAR_01_:
	case E_MONSTAR_02_:

		game.CreateObject(LIST_EXP_,BIG_GROUND_EXP_,fvPosition);
		break;
	case E_GUNBORT_:
		game.CreateObject(LIST_G_ENEMY_,E_GUNBORT_DESTROYED_,fvPosition);
		break;
	default:
		game.CreateObject(LIST_EXP_,EXPROSE_GROUND_EXP_,fvPosition);
        //Ղc悤ɂ(GNeutral)
		break;
	}
}

/***************************
	
***************************/
void CGEnemy::Hit(float shot_power,Vector2<float> target_pos){
	Data.fHP-=shot_power;
	if(Data.fHP<0)Collapse();
	Data.bHitting=true;
}


/***************************
	\
***************************/
void CGEnemy::DrawSP(SDL_Surface *pat1,SDL_Surface *pat2,SDL_Surface *pat3,SDL_Surface *dest){
	CozyRect src;
	Vector2<float> pos;
	short polypointsx[4],polypointsy[4];

	switch(nEnemyType){
	case E_PUMP_01_:case E_PUMP_02_:case E_PUMP_03_:
	case E_BOSS_01_:case E_BOSS_02_:case E_BOSS_03_:case E_BOSS_04_:
		Draw(pat2,dest);
		src.SetRect(352,128,26,26);
		pos.SetVector(-2,-2);
		pos.AddVector(fvPosition);
		CObject::Draw(pos,src,pat1,dest);
		break;
	case E_G_MOUNTAIN_01_:
		Draw(pat2,dest);
		if(Data.nCounter%6>3){
			//C]`
			src.SetRect(96,32,16,16);
			pos.SetVector(-2,-2);
			pos.AddVector(fvPosition);
			CObject::Draw(pos,src,pat1,dest);
		}
		break;
	case E_G_MOUNTAIN_02_:
		Draw(pat2,dest);
		if(Data.nCounter%6>3){
			src.SetRect(96,32,16,16);
			pos.SetVector(-2,-2);
			pos.AddVector(fvPosition);
			CObject::Draw(pos,src,pat1,dest);
		}
		if(Data.nCounter==1){
			Data.fShotInterval=100;
		}else if(Data.nCounter>=50 && Data.nTurn==0){
			//`璼ւƕω
			if(Data.fShotInterval<=5){
				Data.fShotInterval=5.f;
				Data.nTurn=1;
			}else{
				Data.fShotInterval-=2.f;
			}
			//[U[Ə̕\
			polypointsx[0]=fvPosition.fX-5;
			polypointsy[0]=fvPosition.fY-5;
			polypointsx[1]=fvPosition.fX+5;
			polypointsy[1]=fvPosition.fY+5;

			polypointsx[2]=fvPosition.fX+Data.fShotInterval;
			polypointsy[2]=480;
			polypointsx[3]=fvPosition.fX-Data.fShotInterval;
			polypointsy[3]=480;

			filledPolygonRGBA(dest,(short*)polypointsx,polypointsy,4,
				255,100,0,100*sin(DegreeToRadian(Data.nCounter*10)));
			//
			filledPolygonRGBA(dest,(short*)polypointsx,polypointsy,4,
				255,255,255,50);
		}
		break;
	case E_GUNBORT_:
		Draw(pat1,dest);
		//7,31
		pos.SetVector(-12,-4);
		pos.AddVector(fvPosition);
		src.SetRect(192,48,16,16);
		CObject::DrawLT(pos,src,pat1,dest);
		break;
	case E_L_CANNON_:
	case E_TRAIN_GUNNER_:
	case E_TRAIN_GUNNER_SPACE_:
		Draw(pat2,dest);
		break;
	default:
		Draw(pat1,dest);
		break;
	}

	//ϋv͕\
	if(nEnemyType>=E_BOSS_01_ && nEnemyType<=E_BOSS_04_){
		game.DrawBossHP(Data.fHP,Data.fHPMax);
	}
}
