#include "stdafx.h"
#include "CGNeutral.h"
#include "CGame.h"

extern CGame game;

void CGNeutral::CommonInitGNeutral(int type){
	CommonInitEnemy(type);
	Data.nTurn=0;
	Data.nCounter=0;
	Data.fAccel=GNeutralData.fAccel;

	float speed=GNeutralData.fSpeedSlow;
	float hp=GNeutralData.fHP,score=GNeutralData.fScore;
	CozyRect src;
	float r=GNeutralData.fRadiation;

	switch(type){
	case E_GENERATOR_01_:
	case E_GENERATOR_02_:
		src=GNeutralData.TankGenerator.frSrcRect;
		hp*=GNeutralData.TankGenerator.fHPDiv;
		score*=GNeutralData.TankGenerator.fScoreDiv;

		Data.fShotInterval=20;
		speed=0;
		//4Ɍ肵Ă邪Axʂ͋B
		//fvDirection.AngleToVector(
		//	DegreeToRadian(fvDirection.ChangeDirectionN(4)*90));
		r+=15;
		break;
	case E_V_WAGON_:
		src=GNeutralData.VWagon.frSrcRect;
		hp*=GNeutralData.VWagon.fHPDiv;
		score*=GNeutralData.VWagon.fScoreDiv;
		r+=10;
		break;
	case E_H_WAGON_:
		src=GNeutralData.HWagon.frSrcRect;
		hp*=GNeutralData.HWagon.fHPDiv;
		score*=GNeutralData.HWagon.fScoreDiv;
		r+=10;
		break;
	case E_DEKU_:
		src=GNeutralData.Deku.frSrcRect;
		hp*=GNeutralData.Deku.fHPDiv;
		score*=GNeutralData.Deku.fScoreDiv;

		speed=0;
		break;
	case E_ITEM_BOX_:
		src=GNeutralData.ItemBox.frSrcRect;
		hp*=GNeutralData.ItemBox.fHPDiv;
		score*=GNeutralData.ItemBox.fScoreDiv;

		speed=0;
		break;
	case E_HIDDEN_YEN_:
	case E_HIDDEN_BOMB_:
	case E_HIDDEN_UP_:
	case E_HIDDEN_ROI_:
		src=GNeutralData.Hidden.frSrcRect;
		hp*=GNeutralData.Hidden.fHPDiv;
		score*=GNeutralData.Hidden.fScoreDiv;

		speed=0;
		break;
    case E_YEN_:
		src=GNeutralData.Yen.frSrcRect;
		hp*=GNeutralData.Yen.fHPDiv;
		score*=GNeutralData.Yen.fScoreDiv;

		Data.animeID=CAnime(GNeutralData.fYenAnimeIDLimit,GNeutralData.fYenAnimeFrameWait,
			ONLY_ONE_ANIME_);
		speed=0;
		break;
	case E_BOMB_:
		src=GNeutralData.Bomb.frSrcRect;
		hp*=GNeutralData.Bomb.fHPDiv;
		score*=GNeutralData.Bomb.fScoreDiv;

		speed=0;
		bHittable=false;
		bDestroyable=false;
		game.player.Data.nNumOfBombs+=2;
		game.se[WAV_GET_ITEM_].Play();
		break;
	case E_UP_:
		src=GNeutralData.Up.frSrcRect;
		hp*=GNeutralData.Up.fHPDiv;
		score*=GNeutralData.Up.fScoreDiv;

		speed=0;
		bHittable=false;
		bDestroyable=false;
		game.player.Data.nRest+=2;
		game.se[WAV_1UP_].Play();
		break;
	case E_ROI_:
		src=GNeutralData.Roi.frSrcRect;
		hp*=GNeutralData.Roi.fHPDiv;
		score*=GNeutralData.Roi.fScoreDiv;

		speed=GNeutralData.fSpeedFast;
		bHittable=false;
		bDestroyable=false;
		break;
	case E_STOP_DOG_:
		src=GNeutralData.StopDog.frSrcRect;
		hp*=GNeutralData.StopDog.fHPDiv;
		score*=GNeutralData.StopDog.fScoreDiv;

		speed=0;
		break;
	case E_TROUGH_LOOF_:
		src=GNeutralData.TroughLoof.frSrcRect;
		hp*=GNeutralData.TroughLoof.fHPDiv;
		score*=GNeutralData.TroughLoof.fScoreDiv;

		speed=0;
		bHittable=false;
		bDestroyable=false;
		break;
	case E_UN_TROUGH_LOOF_:
		src=GNeutralData.UnTroughLoof.frSrcRect;
		hp*=GNeutralData.UnTroughLoof.fHPDiv;
		score*=GNeutralData.UnTroughLoof.fScoreDiv;

		speed=0;
		bHittable=false;
		bDestroyable=false;
		break;
	case E_STOP_STRAY_:
		src=GNeutralData.StopStray.frSrcRect;
		hp*=GNeutralData.StopStray.fHPDiv;
		score*=GNeutralData.StopStray.fScoreDiv;
		speed=0;
		break;

	case E_STOP_HELI_:
		src=GNeutralData.StopHeli.frSrcRect;
		hp*=GNeutralData.StopHeli.fHPDiv;
		score*=GNeutralData.StopHeli.fScoreDiv;

		speed=0;
		break;
	case E_STOP_YELLOW_:
		src=GNeutralData.StopYellow.frSrcRect;
		hp*=GNeutralData.StopYellow.fHPDiv;
		score*=GNeutralData.StopYellow.fScoreDiv;
		speed=0;
		break;
	}
	fSpeed=speed;
	frSrcRect=src;
	Data.fHP=hp;
	Data.fScore=score;
	fRadiation=r;

	if(Data.fShotInterval==0)Data.fShotInterval=1;
}

/*********************
	RXgN^
*********************/
CGNeutral::CGNeutral(int type,Vector2<float> pos0,Vector2<float> dir0)
:CEnemy(type,pos0,dir0){
	CommonInitGNeutral(type);
}

/*********************
	ړƍXV
*********************/
void CGNeutral::Move(float scroll_speed){
	BasicMove();
	fvPosition.fY+=scroll_speed;
	if(!CheckSeekable())bAlive=false;
	Data.nCounter++;

	int i;
	Vector2<float> temp_pos,temp_dir;


	switch(nEnemyType){
	case E_GENERATOR_01_:
		if(Data.nCounter>64 && Data.nCounter<512 &&
			Data.nCounter%(int)Data.fShotInterval==0){
			//Ԑ
			game.CreateObject(LIST_G_ENEMY_,E_TANK_,fvPosition,fvDirection);
		}
		break;
	case E_GENERATOR_02_:
		if(Data.nCounter==80){
			//Ԑ
			for(i=0;i<4;i++){
				temp_dir.AngleToVector(fvDirection.VectorToAngle()+DegreeToRadian(i*90));
				game.CreateObject(
					LIST_G_ENEMY_,E_RUN_AND_STOP_TANK_,fvPosition,temp_dir);
			}
		}

		break;
	case E_V_WAGON_:
	case E_H_WAGON_:
	case E_DEKU_:
	case E_ITEM_BOX_:
	case E_HIDDEN_YEN_:
	case E_HIDDEN_BOMB_:
	case E_HIDDEN_UP_:
	case E_HIDDEN_ROI_:
	case E_TROUGH_LOOF_:
	case E_UN_TROUGH_LOOF_:
	case E_STOP_STRAY_:
	case E_STOP_HELI_:
	case E_STOP_YELLOW_:
		//Ȃ
		break;
	case E_STOP_DOG_:
		//o
		break;
	case E_YEN_:
		//ŏAj[VB̌ωȂ
		if(Data.nTurn==0){
			frSrcRect.fX=Data.animeID.GetID()*16.f+GNeutralData.Yen.frSrcRect.fX;
			if(Data.animeID.Execute()!=0)Data.nTurn=1;
		}
		break;
	case E_BOMB_:
	case E_UP_:
		break;
	case E_ROI_:
		//㏸ȂACeoĂB
		fvDirection.SetVector(sin(10*DegreeToRadian(Data.nCounter)),-fabs(DegreeToRadian(Data.nCounter)));
		if(Data.nCounter%(int)(10)==0){
			CreateItem();
		}
		break;
	}
}

/*********************
	j
*********************/
void CGNeutral::Collapse(void){
	bAlive=false;
	AddScore();
	int i,n;
	Vector2<float> temp_pos,temp_dir;

	/*------------------
		ʐݒ
	------------------*/
	switch(nEnemyType){
	case E_ITEM_BOX_:
		game.CreateObject(LIST_EXP_,EXPROSE_GROUND_EXP_,fvPosition);
		CreateItem();
		break;
	case E_GENERATOR_01_:
	case E_GENERATOR_02_:
		game.CreateObject(LIST_EXP_,BIG_GROUND_EXP_,fvPosition);
		break;
	case E_V_WAGON_:
	case E_H_WAGON_:
		game.CreateObject(LIST_EXP_,BIG_GROUND_EXP_,fvPosition);
		n=6*GameData.nLevel;
		for(i=0;i<n;i++){
			temp_pos.AngleToVector(DegreeToRadian(i*(360.f/n)+90));
			temp_dir=temp_pos;
			temp_pos.AddVector(fvPosition);
			game.CreateObject(LIST_E_SHOT_,LARGE_SHOT_,temp_pos,temp_dir,
				0.3f);
		}
		break;
	case E_HIDDEN_YEN_:
		game.CreateObject(LIST_G_NEUTRAL_,E_YEN_,fvPosition);
		break;
	case E_HIDDEN_BOMB_:
		game.CreateObject(LIST_G_NEUTRAL_,E_BOMB_,fvPosition);
		break;
	case E_HIDDEN_UP_:
		game.CreateObject(LIST_G_NEUTRAL_,E_UP_,fvPosition);
		break;
	case E_HIDDEN_ROI_:
		game.CreateObject(LIST_G_NEUTRAL_,E_ROI_,fvPosition);
		break;
	case E_STOP_DOG_:
		game.CreateObject(LIST_EXP_,BIG_GROUND_EXP_,fvPosition);
		game.CreateObject(LIST_ITEM_,ITEM_BOMB_,fvPosition);
		break;
	default:
		game.CreateObject(LIST_EXP_,EXPROSE_GROUND_EXP_,fvPosition);
	}
}

/*********************
	ړƍXV
*********************/
void CGNeutral::Hit(float shot_power){
	Data.fHP-=shot_power;
	Data.bHitting=true;
	if(Data.fHP<0){
		Collapse();
	}
}

void CGNeutral::DrawSP(SDL_Surface *pat1,SDL_Surface *pat2,SDL_Surface *pat3,SDL_Surface *dest){
	switch(nEnemyType){
	case E_GENERATOR_01_:
	case E_GENERATOR_02_:
	case E_TROUGH_LOOF_:
		Draw(pat2,dest);
		break;
	case E_STOP_DOG_:
	case E_UN_TROUGH_LOOF_:
		Draw(pat3,dest);
		break;
	default:
		Draw(pat1,dest);
		break;
	}
}
