#include "stdafx.h"
#include "CGame.h"

extern int item_counter;

/*----------------------------------*
	constructor
*----------------------------------*/
CGame::CGame(){
	SDLSet=CSDLManager();

	int win_mode=FULL_SCREEN_MODE_;
	if(GameData.nScreenMode)win_mode=WINDOW_MODE_;
	SDLSet.InitSDL(GameData.fvScreenSize.fX,GameData.fvScreenSize.fY,win_mode);
	SDLSet.InitAudio();
	Mix_SetMusicPosition(0);
	//	set window title
	SDL_WM_SetCaption("Bullet SDL","Bullet SDL");

	//set mini icon
	SDL_Surface *icon;
	SDLSet.LoadBMP("./bmp/icon.bmp",&icon);
	SDLSet.SetInvisibleColor(255,255,255,&icon);
	SDL_WM_SetIcon(icon,NULL);

	//WCXeBbNI[v
	joy=SDL_JoystickOpen(0);
	if(!SDL_JoystickOpened(0)){
		//warning
		fprintf(stderr,"WCXeBbN0I[vł܂łB\n");
	}

	bWindowed_=true;
	nNowPlayingMusicNum_=0;
	keys=0;
	replay_manager=CReplay();
}

/*----------------------------------*
	destractor
*----------------------------------*/
CGame::~CGame(){
	FreeAll();
}


/*----------------------------------*
	system-initialization
*----------------------------------*/
void CGame::Init(void){

	//g̊G
	oFrame=CObject(OTHER_,
		Vector2<float>::GetVector(GameData.fvScreenSize.fX/2.f,GameData.fvScreenSize.fY/2.f),nullVector2,
		0,0);
	oFrame.frSrcRect.SetRect(0,0,GameData.fvScreenSize.fX,GameData.fvScreenSize.fY);

	LoadImages();
	LoadSEs();
	LoadMusics();

	/*------------------------------------
	//	}bvǂݍ
	------------------------------------*/
	//}bvXgǂݍ
	timer_manager.InputMapFileListFile("./data/map_list.txt");

	nState_=STATE_TITLE_;
//	nStage_=1;
}

/*----------------------------------*
	Q[̏
*----------------------------------*/
void CGame::SetInitialSetting(void)
{
	bgmanager.fScrollSpeed=1.f;
	ReplayMode_=0;

	//}bvXg
	timer_manager.ResetNameListIterator();

	FreeObjects();

	player=CPlayer();
	sScore.Reset();

}

/*----------------------------------*
	load images
*----------------------------------*/
void CGame::LoadImages(void)
{
	char* sPAT1_BMP="./bmp/cha01.bmp";
	char* sPAT2_BMP="./bmp/cha02.bmp";
	char* sPAT3_BMP="./bmp/cha03.bmp";
	char* sPAT1_HIT_BMP="./bmp/cha01_hit.bmp";
	char* sPAT2_HIT_BMP="./bmp/cha02_hit.bmp";
	char* sPAT3_HIT_BMP="./bmp/cha03_hit.bmp";
	char* sFRAME_BMP="./bmp/frame.bmp";
	char* sBG_00_BMP="./bmp/bg00.bmp";

	SDLSet.LoadBMP(sPAT1_BMP,&sPat1);
	SDLSet.LoadBMP(sPAT2_BMP,&sPat2);
	SDLSet.LoadBMP(sPAT3_BMP,&sPat3);
	SDLSet.LoadBMP(sPAT1_HIT_BMP,&sPat1Hit);
	SDLSet.LoadBMP(sPAT2_HIT_BMP,&sPat2Hit);
	SDLSet.LoadBMP(sPAT3_HIT_BMP,&sPat3Hit);
	SDLSet.LoadBMP(sBG_00_BMP,&sBG00);
	SDLSet.LoadBMP("./bmp/title.jpg",&sTitle);

	//t[
	SDLSet.LoadBMP(sFRAME_BMP,&sFrame);

	//ߐFݒ
	SDLSet.SetInvisibleColor(255,255,255,&sPat1);
	SDLSet.SetInvisibleColor(255,255,255,&sPat2);
	SDLSet.SetInvisibleColor(255,255,255,&sPat3);
	SDLSet.SetInvisibleColor(0,0,0,&sPat1Hit);
	SDLSet.SetInvisibleColor(0,0,0,&sPat2Hit);
	SDLSet.SetInvisibleColor(0,0,0,&sPat3Hit);
	SDLSet.SetInvisibleColor(255,255,255,&sFrame);
	//^Cg͑S`悷̂Őݒ͕sv
}

/*----------------------------------*
	ʉǂݍ
*----------------------------------*/
void CGame::LoadSEs(void)
{
	int i,channel=0;
	for(i=0;i<WAV_MAX_;i++){
		se[i].LoadFile(sefname[i],0);
	}
}

/*----------------------------------*
	MUSIC(MIDI)ǂݍ
*----------------------------------*/
void CGame::LoadMusics(void)
{
	for(int i=0;i<MUSIC_MAX_;i++){
		music[i].LoadFile(musicfname[i]);
	}
}

/*----------------------------------*
	Q[is
*----------------------------------*/
void CGame::Start()
{
	FreeObjects();
	srand(100);

	/*vC[*/
	player.Reset(false);

	replay_manager.ClearList();
	if(ReplayMode_){
		int p_bombs,p_rests,p_m_type,p_m_pow,p_s_type,p_s_pow;
		replay_manager.LoadReplayFile(nStage_,
			&p_bombs,&p_rests,&p_m_type,&p_m_pow,&p_s_type,&p_s_pow);
		player.Data.nNumOfBombs=p_bombs;
		player.Data.nRest=p_rests;
		player.Data.nMainShotType=p_m_type;
		player.Data.nMainShotLevel=p_m_pow;
		player.Data.nSubShotType=p_s_type;
		player.Data.nSubShotLevel=p_s_pow;
	}
	
	old_player=player;

	item_counter=0;

	//ACe
	nGotItemsNum_=0;

	//Xebv
	timer_manager.ResetStep();
	timer_manager.ResetTimerListIterator();

	//ŏɕ\镔̔wi
	bgmanager.InitCreate();

	nStageTitleShowTime_=nSTAGE_TITLE_SHOW_TIME;
	
	int nGameOverCounter=0;
	int nGameClearCounter=0;

	bool bCleared=false,bLoop=true;
	bPause_=false;

	Mix_VolumeMusic(0.8);
//	float fVolume=Mix_VolumeMusic(-1);//݂̉y
//	float fVolReduceSpeed=1.f;//tF[hAEg̑x
//	float fOldVolume=fVolume;

//	CObject obj=CObject(0,Vector2<float>::GetVector(100,100),
//		nullVector2,0,0,CozyRect::GetRect(0,64,32,32));

	while(bLoop){//i[v
		SDLSet.WaitStartCheck();
		//eXg
//		SDLSet.ClearScreen();

		/*------------------------------*
		*				\			*
		*------------------------------*/
		DrawGame();
//		static float angle=0;
//		angle+=1;

//		obj.RotZoomDraw(sPat1,SDLSet.sScreen,angle,0.5,1);

		//	Xe[^X\
		DrawStatus();

		/*------------------------------
				L[
		------------------------------*/
		//	L[XL
		SDLSet.GetKey();

		//L[Cxg
		KeyEvent();
		int result_reply=0;

		if(!bPause_){
			if(ReplayMode_){
				result_reply=replay_manager.SetKey(&keys);
			}else{
				replay_manager.AddIterator(keys);
			}
		}

		if(result_reply<0){
			//vCI
			//vCI͂΂炭҂Ă^CgʂցB
			nGameClearCounter++;

			CUsagiString::DrawString(190,150,
				"REPLAY OVERED",0,sPat3,SDLSet.sScreen);
			if(nGameClearCounter>GameData.nWaitAfterGameClear){
				nState_=STATE_TITLE_;
				FreeObjects();
				return;
			}
		}
		//^Cg֋A
		if(SDLSet.Key[SDLK_F2]){
			nState_=STATE_TITLE_;
			FreeObjects();
			return;
		}

		/*----------------------------------*
		*	XV	*
		*----------------------------------*/
		if(!bPause_){
			//	v[[
			if(!player.bGameOver){
				int check_bomb=player.Move(keys);
				if(check_bomb!=0){
					//G̒e
					FreeEnemyShot();
				}
			}else{
				nGameOverCounter++;
				CUsagiString::DrawString(200,180,
					"GAME OVER",0,sPat3,SDLSet.sScreen);

				if(nGameOverCounter>GameData.nWaitAfterGameOver){
					nState_=STATE_GAME_OVER_;
					return;
				}
			}
			PlayerShotUpdate();
			EnemyShotUpdate();

			int is_boss_collapsed=0;
			is_boss_collapsed+=SkyEnemyUpdate();
			is_boss_collapsed+=GEnemyUpdate(bgmanager.fScrollSpeed);
			if(is_boss_collapsed!=0){
				bCleared=true;
			}
			SkyNeutralUpdate();
			GNeutralUpdate(bgmanager.fScrollSpeed);

			PieceUpdate();
			ExpUpdate(bgmanager.fScrollSpeed);
			SmokeUpdate();

			ItemUpdate();

			BGUpdate(bgmanager.fScrollSpeed);

			/*----------------------------------
				G
			----------------------------------*/
			int get_command=timer_manager.CreateEnemy();
			if(!bCleared && !player.bGameOver 
				&& TIMER_EVENT_CHANGE_BGM_BORDER_<=get_command &&
				TIMER_EVENT_CHANGE_SCROLL_SPEED_BORDER_>get_command){
				//BGMύX
				music[nNowPlayingMusicNum_].StopBGM();
				nNowPlayingMusicNum_=get_command-TIMER_EVENT_CHANGE_BGM_BORDER_;
				music[nNowPlayingMusicNum_].StartBGM(-1);

			}
			if(TIMER_EVENT_CHANGE_SCROLL_SPEED_BORDER_<=get_command){
				bgmanager.fScrollSpeed=get_command-TIMER_EVENT_CHANGE_SCROLL_SPEED_BORDER_;
			}
			if(get_command==-1 || get_command==TIMER_EVENT_END_STAGE_){
				//Xg̖
				bCleared=true;
			}

			//NA[͂΂炭҂ĂXRAʂցB
			if(bCleared){
				nGameClearCounter++;

				//tF[hAEg
//				fVolume-=fVolReduceSpeed;

				CUsagiString::DrawString(190,220,
					"GAME CLEARED",0,sPat3,SDLSet.sScreen);
				if(nGameClearCounter>GameData.nWaitAfterGameClear){
					nState_=STATE_CELARED_;
//					Mix_VolumeMusic((int)fOldVolume);
					return;
				}
			}
			
			//wiXV
			bgmanager.Update(timer_manager.GetStep());

			/*----------------------------------
				^C}[Xebvis
			----------------------------------*/
			timer_manager.AddStep();

		}else{
			//|[Y
			//curtain
			DrawCurtain(150);
			//string
			CUsagiString::DrawString(200,200,"PAUSE",0,sPat3,SDLSet.sScreen);
		}
		
		/*--------------------------
				
		--------------------------*/
		SDLSet.EventExecute();

		/*----------------------------------
			flip screen
		----------------------------------*/
		SDL_Flip(SDLSet.sScreen);

		/*----------------------------------
			delay
		----------------------------------*/
		SDLSet.WaitExecute(GameData.fMaxWait);
	}
}

/*----------------------------------*
	L[Cxg
	out:int:next state
			0:no change 
			1:go to title
*----------------------------------*/
int CGame::KeyEvent()
{
	int reply=0;

	static int snap_interval_counter=0;
	//PrintScreen=[snap shot]
	snap_interval_counter++;
	if(snap_interval_counter>10 && SDLSet.Key[SDLK_HOME]){
		snap_interval_counter=0;
		SDLSet.SaveScreenShot();
	}

	//Reset stage
	if(SDLSet.Key[SDLK_F6]){
		timer_manager.ResetTimerListIterator();
		timer_manager.ResetStep();
	}
	
	if(SDLSet.Key[SDLK_ESCAPE]){
//		FreeAll();
		exit(0);
	}

	if(SDLSet.Key[SDLK_F1]){
		if(bWindowed_){
			SDLSet.sScreen=SDL_SetVideoMode(
				GameData.fvScreenSize.fX,GameData.fvScreenSize.fY,16,SDL_SWSURFACE);
			bWindowed_=false;
		}else{
			SDLSet.sScreen=SDL_SetVideoMode(
				GameData.fvScreenSize.fX,GameData.fvScreenSize.fY,16,SDL_SWSURFACE|SDL_FULLSCREEN);
			bWindowed_=true;
		}
	}
	keys=0;
	//vC[L[
	if(SDLSet.Key[SDLK_x]){
		keys|=KEY_X;
	}
	if(SDLSet.Key[SDLK_z]){
		keys|=KEY_Z;
	}
	if(SDLSet.Key[SDLK_UP]){
		keys|=KEY_UP;
	}
	if(SDLSet.Key[SDLK_DOWN]){
		keys|=KEY_DOWN;
	}
	if(SDLSet.Key[SDLK_LEFT]){
		keys|=KEY_LEFT;
	}
	if(SDLSet.Key[SDLK_RIGHT]){
		keys|=KEY_RIGHT;
	}
	//WCXeBbN͂ϊ(ƂقǂłȂ)
	if(SDL_JoystickOpened(0)){
		if(SDL_JoystickGetAxis(joy,0)>1000){
			keys|=KEY_RIGHT;
		}if(SDL_JoystickGetAxis(joy,0)<-1000){
			keys|=KEY_LEFT;
		}if(SDL_JoystickGetAxis(joy,1)>1000){
			keys|=KEY_DOWN;
		}if(SDL_JoystickGetAxis(joy,1)<-1000){
			keys|=KEY_UP;
		}if(SDL_JoystickGetButton(joy,0)){
			keys|=KEY_Z;
		}if(SDL_JoystickGetButton(joy,2)){
			keys|=KEY_X;
		}
	}

	static int pause_interval_counter=0;
	pause_interval_counter++;
	if((SDLSet.Key[SDLK_p] ||SDL_JoystickGetButton(joy,4))
		&& pause_interval_counter>10){
		//get paused
		bPause_=!bPause_;
		pause_interval_counter=0;
	}

	return reply;
}

/*----------------------------------*
	Draw sprites
*----------------------------------*/
void CGame::DrawGame()
{
	DrawList(bg_list,sBG00);

	//Draw Ground's sprite
	DrawHittableListSP(sPat1,sPat2,sPat3,g_e_list);
	DrawHittableListSP(sPat1,sPat2,sPat3,g_n_list);

	DrawShadow();

	//	Draw player
	static int p_blink_counter=0;
	if(!player.bGameOver){
		if(p_blink_counter==0 && !bPause_ &&
			(player.Data.nCheat==INV_ || player.Data.nCheat==GOD_)){
			SDL_SetAlpha(sPat1,SDL_SRCALPHA, (Uint8)(150));
			p_blink_counter=(p_blink_counter+1)%2;
		}else p_blink_counter=0;
		player.Draw(sPat1,SDLSet.sScreen);
		if(player.Data.nCheat==INV_ || player.Data.nCheat==GOD_){
			SDL_SetAlpha(sPat1,SDL_SRCALPHA, (Uint8)(255));
		}
	}

	//Draw above ground
	DrawList(smoke_list,sPat1);
	DrawHittableListSP(sPat1,sPat2,sPat3,sky_e_list);
	DrawHittableListSP(sPat1,sPat2,sPat3,sky_n_list);

	//Draw Player Shot
	SDL_SetAlpha(sPat1,SDL_SRCALPHA, (Uint8)(150));
	CGame::DrawListSP(sPat1,sPat2,sPat3,p_shot_list);
	SDL_SetAlpha(sPat1,SDL_SRCALPHA, (Uint8)(255));

//	SDL_SetAlpha(sPat1,SDL_SRCALPHA, (Uint8)(150));
	DrawList(piece_list,sPat1);
	DrawList(exp_list,sPat1);
//	SDL_SetAlpha(sPat1,SDL_SRCALPHA, (Uint8)(255));

	DrawList(item_list,sPat1);

	//	The most important sprites -Enemy shots!-
	DrawListSP(sPat1,sPat2,sPat3,e_shot_list);

	//scores
	for(std::list<CScore>::iterator sc_it=score_list.begin();
	sc_it!=score_list.end();){
		sc_it->Move();
		sc_it->PrintObj(sPat3,SDLSet.sScreen);
		if(sc_it->IsAlive()){
			sc_it++;
		}else{
			sc_it=score_list.erase(sc_it);
		}
	}

	//Draw Stage infomation
	if(nState_!=STATE_ENDING_ && nStageTitleShowTime_>0){
		sprintf(buf,"STAGE %s",IntToString(nStage_,2));
		CUsagiString::DrawString(180,200,buf,0,sPat3,SDLSet.sScreen);
		nStageTitleShowTime_--;
	}else if(nState_==STATE_ENDING_){
		CUsagiString::DrawString(180,80,
			"ENDING@STAFF ROLL",0,sPat3,SDLSet.sScreen);
		//nStageTitleShowTime_--;
	}		
	
	//Frame Draw
	oFrame.Draw(sFrame,SDLSet.sScreen);
}

/*----------------------------------*
	Game Reset
*----------------------------------*/
void CGame::Reset(void)
{
}

/*----------------------------------*
	Free All
*----------------------------------*/
void CGame::FreeAll(void)
{
	SDL_FreeSurface(sPat1);
	SDL_FreeSurface(sPat2);
	SDL_FreeSurface(sPat3);
	SDL_FreeSurface(sPat1Hit);
	SDL_FreeSurface(sPat2Hit);
	SDL_FreeSurface(sPat3Hit);
	SDL_FreeSurface(sFrame);
	SDL_FreeSurface(sBG00);
	SDL_FreeSurface(sTitle);

	SDL_FreeSurface(sSurf1);
	SDL_FreeSurface(sSurf2);
	SDL_FreeSurface(sSurf3);
	FreeObjects();
}

/*----------------------------------*
	Free Objects
*----------------------------------*/
void CGame::FreeObjects(void)
{
	FreeEnemy();

	piece_list.clear();
	exp_list.clear();
	smoke_list.clear();
	
	p_shot_list.clear();
	FreeEnemyShot();
	
	item_list.clear();

	bg_list.clear();
}

/*----------------------------------*
	Free Only Enemy
*----------------------------------*/
void CGame::FreeEnemy(){
	sky_e_list.clear();
	sky_n_list.clear();
	g_e_list.clear();
	g_n_list.clear();
}

/*----------------------------------*
	Free Only Enemy Shots
*----------------------------------*/
void CGame::FreeEnemyShot(void)
{
	e_shot_list.clear();
}


/*----------------------------------*
	Draw Status
*----------------------------------*/
void CGame::DrawStatus(void){
	//Status Drawing

	//Status offset
	//status_left	=	Rest's left,or Introductry notes
	//status_item_left=	power indexes
	int status_left=512,status_item_left=530,status_main_power_y=166,
		status_sub_power_y=186,status_bombs_y=236,status_rest_y=280;

	CObject item;
	SDL_Surface *pat=sPat3;

	int i;
	//Rest
	item.frSrcRect.SetRect(16.f*12,16.f*3,16.f,16.f);
	for(i=0;i<player.Data.nRest;i++){
		if(player.Data.nRest==0)break;
		if(i>6)break;
		item.fvPosition.SetVector(i*10+status_left,status_rest_y);
		item.Draw(pat,SDLSet.sScreen);
	}
	//Bombs
	item.frSrcRect.SetRect(16.f*11,16.f*3.f,16.f,16.f);
	for(i=0;i<player.Data.nNumOfBombs;i++){
		if(player.Data.nNumOfBombs==0)break;
		if(i>6)break;
		item.fvPosition.SetVector(i*10.f+status_left,status_bombs_y);
		item.Draw(pat,SDLSet.sScreen);
	}

	//Shot power
	//MainShot
	item.fvPosition.SetVector(status_left,status_main_power_y);
	switch(player.Data.nMainShotType){
	case P_BALKAN_:
		item.frSrcRect.SetRect(16.f,16.f*3,16.f,16.f);
		item.Draw(pat,SDLSet.sScreen);
		break;
	case P_KAKUSAN_:
		item.frSrcRect.SetRect(16.f*2,16.f*3.f,16.f,16.f);
		item.Draw(pat,SDLSet.sScreen);
		break;
	case P_LASER_:
		item.frSrcRect.SetRect(16.f*3,16.f*3.f,16.f,16.f);
		item.Draw(pat,SDLSet.sScreen);
		break;
	}
	for(i=0;i<5;i++){
		int x=(int)(i*16)+status_item_left;
		if(i<player.Data.nMainShotLevel){
			item.frSrcRect.SetRect(16.f*8,16.f*3,16.f,16.f);
			item.fvPosition.fX=(float)x;
			item.Draw(pat,SDLSet.sScreen);
		}else{
			item.frSrcRect.SetRect(16.f*7,16.f*3.f,16.f,16.f);
			item.fvPosition.SetVector((float)x,(float)status_main_power_y);
			item.Draw(pat,SDLSet.sScreen);
		}

	}

	//Sub
	item.fvPosition.SetVector(status_left,status_sub_power_y);
	switch(player.Data.nSubShotType){
	case P_NO_SUB_:
		break;
	case P_HOMING_:
		item.frSrcRect.SetRect(16.f*6,16.f*3,16.f,16.f);
		item.Draw(pat,SDLSet.sScreen);
		break;
	case P_MISSILE_:
		item.frSrcRect.SetRect(16.f*5,16.f*3,16.f,16.f);
		item.Draw(pat,SDLSet.sScreen);
		break;
	}
	for(i=0;i<2;i++){
		int x=i*(int)16.f+status_item_left;
		if(i<player.Data.nSubShotLevel){
			item.frSrcRect.SetRect(16.f*9,16.f*3,16.f,16.f);
			item.fvPosition.fX=(float)x;
			item.Draw(pat,SDLSet.sScreen);
		}else{
			item.frSrcRect.SetRect(16.f*7,16.f*3,16.f,16.f);
			item.fvPosition.SetVector((float)x,(float)status_sub_power_y);
			item.Draw(pat,SDLSet.sScreen);
		}
	}

	//	Score(Warn to memory leak!
	sScore.Print(pat,SDLSet.sScreen);
}

