#ifndef _C_GAME_H_
#define _C_GAME_H_

/*************************************************
	includes
*************************************************/
#include "stdafx.h"
#include "CSDLManager.h"
#include "CTimerManager.h"
#include "CBGManager.h"

#include "CShot.h"
#include "CSkyNeutral.h"
#include "CGNeutral.h"
#include "CSkyEnemy.h"
#include "CGEnemy.h"
#include "CPlayer.h"
#include "CItem.h"
#include "CPiece.h"
#include "CExp.h"
#include "CSmoke.h"

#include "CScore.h"

#include "CBG.h"

#include "CMusic.h"
#include "CSE.h"

#include "CReplay.h"

//sound effects name
enum{
	WAV_1UP_,
	WAV_ALART_,
	WAV_BCG9001_,	//player's bomb
	WAV_BIG_BOMB_,
	WAV_BIG_G_,		//big exprosion on the ground
	WAV_BOSS_EXP_,//
	WAV_CHINNG_,//		XRAvZ
	WAV_EXPOSE_G_,//
	WAV_GET_ITEM_,//
	WAV_HIT_,//
	WAV_HUGE_EXPROSE_,//
	WAV_LIGT_EXP_,//	~TCn
	WAV_POT_,//
	WAV_PYO_,//			z[~O~TCn
	WAV_SHOT_,
	WAV_SKY_EXPROSE_,//

	WAV_ENEMY_LARGE_SHOT_,
	WAV_ENEMY_HUGE_SHOT_,
	WAV_MAX_,
	//-----------
	//20040521
	WAV_ENEMY_SMALL_SHOT_,
	WAV_ENEMY_MIDIUM_SHOT_,
	WAV_ENEMY_MIDIUM_S_SHOT_,

//	WAV_MAX_
};

//Xg^Cv
enum{
	LIST_SKY_ENEMY_,
	LIST_SKY_NEUTRAL_,
	LIST_G_ENEMY_,
	LIST_G_NEUTRAL_,

	LIST_P_SHOT_,
	LIST_E_SHOT_,

	LIST_PIECE_,
	LIST_EXP_,
	LIST_SMOKE_,

	LIST_ITEM_,

	LIST_BG_,
	LIST_SCORE_,
};

static char *sefname[]={"./se/1up.wav","./se/alart.wav","./se/BCG9001.wav",
	"./se/Big_bomb.wav","./se/BIG_G.wav","./se/Boss_exp.wav","./se/chinng.wav",
	"./se/expose-G.wav","./se/Get_item.wav","./se/hit.wav","./se/Huge_exprose.wav",
	"./se/light_exp.wav","./se/pot.wav","./se/Pyo.wav","./se/shot.wav","./se/sky_exprose.wav",
	"./se/hit_s11_a.wav","./se/Gun01.wav"};

//BGM
enum{
	MUSIC_GAME_OVER_=0,
	MUSIC_STAGE_01_,
	MUSIC_STAGE_02_,
	MUSIC_BOSS_01_,//3
	MUSIC_BOSS_02_,
	MUSIC_STAGE_03_,
	MUSIC_ENDING_,	//6

	MUSIC_MAX_
};//㑝ĂƂɌɕtĂ
static char *musicfname[]={
	"./bgm/gameover.mid",			//0
	"./bgm/field1.mid",
	"./bgm/BATTLE.MID",
	"./bgm/BGM4.MID",			//3
	"./bgm/buto.mid",
	"./bgm/stage3.mid",
	"./bgm/Wonderful World.MID"		//6
};

//Q[̏
enum{
	STATE_TITLE_,
	STATE_GAME_,
	STATE_GAME_OVER_,
	STATE_CELARED_,
	STATE_ENDING_,
};

const int nSTAGE_TITLE_SHOW_TIME=180;

/*************************************************
	game manager class
	singleton?
*************************************************/
class CGame{
private:
	/*-----------------------
		VXe܂
	-----------------------*/
	//sprites' surfaces
	SDL_Surface *sPat1;
	SDL_Surface *sPat2;
	SDL_Surface *sPat3;
	SDL_Surface *sPat1Hit;
	SDL_Surface *sPat2Hit;
	SDL_Surface *sPat3Hit;
	SDL_Surface *sBG00;//	back ground
	//	gt[
	SDL_Surface *sFrame;

	//^Cg
	SDL_Surface *sTitle;
	
	//timer manager
	CTimerManager timer_manager;

	//back ground manager
	CBGManager bgmanager;

public:
	//]Agk摜[߂ẮBg܂킵B
	SDL_Surface *sSurf1,*sSurf2,*sSurf3;

	//Replay Manager
	CReplay replay_manager;

	CSDLManager SDLSet;
	CPlayer player;
	CPlayer old_player;
private:
	/*-------------
		list of object
	---------------*/

	std::list<CSkyEnemy> sky_e_list;

	std::list<CGEnemy> g_e_list;
	std::list<CSkyNeutral> sky_n_list;
	std::list<CGNeutral> g_n_list;

	std::list<CPiece> piece_list;
	std::list<CExp> exp_list;
	std::list<CSmoke> smoke_list;
	
	std::list<CItem> item_list;
	
	std::list<CShot> p_shot_list;
	std::list<CShot> e_shot_list;
	
	std::list<CBG> bg_list;

	std::list<CScore> score_list;

private:
	/*--------------
		for game
	---------------*/
	bool ReplayMode_;		//is replay mode?
	bool bPause_;
	bool bWindowed_;

	int nStage_;	//Xe[WH
	int nState_;	//Q[͂ǂ̏ԁH
	
private:
	//joystic
	SDL_Joystick *joy;

	//key status for all mity
	int keys;

	//	XRA̐lNX
	CScore sScore;

	//Nt[
	CObject oFrame;

	//ėpobt@
	char buf[128];

	//ustage ??v\Ă鎞
	int nStageTitleShowTime_;

	//̃}bvŎ擾ACe
	int nGotItemsNum_;

public:
	CMusic music[MUSIC_MAX_];
	CSE se[WAV_MAX_];

	// music which is playing now
	int nNowPlayingMusicNum_;
public:	
	/*-----------------------
		functions for game
	-----------------------*/
	CGame();
	~CGame();

	//
	int Title(void);

	int GameOver(void);

	int ClearStage(void);

	int Ending();

	//	initialization of system
	void Init(void);

	//	initialization of game
	void SetInitialSetting(void);

	//	main loop
	void Start();

	//	o׏Ԃɖ߂
	//(}bv̍ŏcStart()ōs)
	void Reset(void);

	//S
	void FreeAll(void);
	//̂̂݉
	void FreeObjects(void);
		//	Ge
		void FreeEnemyShot(void);
		//	free enemies
		void FreeEnemy();

	void DrawBossHP(float hp,float hp_max,int dan=1);

private:
	void LoadImages(void);
	void LoadSEs(void);
	void LoadMusics(void);

	//Q[̕`
	//	ȊÔ̂͒ڋLq
	void DrawGame();

	//ėp
	int KeyEvent();

	void DrawCurtain(int curtain_alpha,CozyRect curtain_src=CozyRect(160,32,16,16),int where_to_draw=0);
	void DrawShadow();

public:
	/*-----------------------
		update
	-----------------------*/
	//	Vbg̃Xg̍XV
	void PlayerShotUpdate(void);
	void EnemyShotUpdate(void);

	//{X񂪕ԂĂ
	int SkyEnemyUpdate(void);
	int GEnemyUpdate(float scroll_speed);

	void SkyNeutralUpdate(void);
	void GNeutralUpdate(float scroll_speed);

	void PieceUpdate(void);
	void ExpUpdate(float scroll_speed);
	void SmokeUpdate(void);
	void ItemUpdate(void);
	void BGUpdate(float scroll_speed);
	void ScoreUpdate(void);
public:
	/*--------------------------
		
	---------------------------*/
	template<class T>void CreateObjectTemplate(int type,Vector2<float> pos0,
		Vector2<float> dir0,float speed_div,std::list<T> *l)
	{
		T item=T(type,pos0,dir0);
		item.fSpeed*=speed_div;
		
		l->push_back(item);
	}


	void CreateObject(int listtype,int type,Vector2<float> pos0,
		Vector2<float> dir0=nullVector2,float speed_div=1);
	void CreatePShot(int type,Vector2<float> pos0,
		Vector2<float> dir0=nullVector2,float speed_div=1);
public:
	void SkipStage(int skip);

	int GetState(){return nState_;}
	int GetStage(){return nStage_;}
	int GetReplayMode(){return ReplayMode_;}

	//_ǉ
	void AddScore(float addscore){
		sScore.Add(addscore);
	}

	// draw status
	void DrawStatus(void);

	//draw list 
	template <class T> void DrawList(std::list<T> &l,
		SDL_Surface *pat)
	{
		for(std::list<T>::iterator it=l.begin();it!=l.end();it++){
			it->Draw(pat,SDLSet.sScreen);
		}
	}

	//draw specially
	template<class T>void DrawListSP(SDL_Surface *pat1,SDL_Surface *pat2,SDL_Surface *pat3,
		std::list<T> &l)
	{
		for(std::list<T>::iterator it=l.begin();it!=l.end();it++){
			it->DrawSP(pat1,pat2,pat3,SDLSet.sScreen);
		}
	}

	//draw hittable objects
	template<class T>void DrawHittableListSP(SDL_Surface *pat1,SDL_Surface *pat2,SDL_Surface *pat3,
		std::list<T> &l)
	{
		for(std::list<T>::iterator it=l.begin();it!=l.end();it++){
			if(it->Data.bHitting){
				it->DrawSP(sPat1Hit,sPat2Hit,sPat3Hit,SDLSet.sScreen);
				it->Data.bHitting=false;
			}else{
				it->DrawSP(pat1,pat2,pat3,SDLSet.sScreen);
			}
		}
	}
};

#endif
