#include "stdafx.h"
#include "CGame.h"

/********************************
	update player's shots
********************************/
void CGame::PlayerShotUpdate()
{
	std::list<CShot>::iterator shot_it;

	Vector2<float> target;
	std::list<CSkyEnemy>::iterator sky_e_it;//use for both ishit & homing
	std::list<CSkyNeutral>::iterator sky_n_it;
	std::list<CGEnemy>::iterator g_e_it;
	std::list<CGNeutral>::iterator g_n_it;

	for(shot_it=p_shot_list.begin();shot_it!=p_shot_list.end();){
		//	check IsHit with enemy
		//SkyEnemy
		for(sky_e_it=sky_e_list.begin();sky_e_it!=sky_e_list.end();sky_e_it++){
			//check is hit
			if(shot_it->IsHittable() && sky_e_it->IsDestroyable() &&
				sky_e_it->IsHit(shot_it->fvPosition,shot_it->fRadiation))
			{
				sky_e_it->Hit(shot_it->Data.fPower,
					player.fvPosition);
				shot_it->Hit();
			}
		}
		for(sky_n_it=sky_n_list.begin();sky_n_it!=sky_n_list.end();sky_n_it++){
			if(shot_it->IsHittable() && sky_n_it->IsDestroyable() &&
				sky_n_it->IsHit(shot_it->fvPosition,shot_it->fRadiation))
			{
				sky_n_it->Hit(shot_it->Data.fPower);
				shot_it->Hit();
			}
		}
		for(g_e_it=g_e_list.begin();g_e_it!=g_e_list.end();g_e_it++){
			if(shot_it->IsHittable() && g_e_it->IsDestroyable() &&
				g_e_it->IsHit(shot_it->fvPosition,shot_it->fRadiation))
			{
				g_e_it->Hit(shot_it->Data.fPower,
					player.fvPosition);
				shot_it->Hit();
			}
		}
		for(g_n_it=g_n_list.begin();g_n_it!=g_n_list.end();g_n_it++){
			if(shot_it->IsHittable() && g_n_it->IsDestroyable() &&
				g_n_it->IsHit(shot_it->fvPosition,shot_it->fRadiation))
			{
				g_n_it->Hit(shot_it->Data.fPower);
				shot_it->Hit();
			}
		}

		//if shot is laser or laser_max, target is player
		if(shot_it->GetType()==P_LASER_SHOT_ ||
			shot_it->GetType()==P_LASER_MAX_SHOT_)
			target=player.fvPosition;

		// search for homing target
		//set near target to homing-target
		//(in shot.cpp)homing only if target is in StageRange
		if(shot_it->GetType()==P_HOMING_SHOT_){
			bool bLockedOn=false;
			Vector2<float> distance;

			for(sky_e_it=sky_e_list.begin();sky_e_it!=sky_e_list.end();sky_e_it++){
				distance.SetVector(sky_e_it->fvPosition.fX-shot_it->fvPosition.fX,
					sky_e_it->fvPosition.fY-shot_it->fvPosition.fY);
				if(fabs(distance.CalcLength())<ShotData.fFindEnemyRange &&
					sky_e_it->IsDestroyable()){
					bLockedOn=true;
					target=sky_e_it->fvPosition;
						break;
				}
			}
			//check locked on?
			if(!bLockedOn){
				for(sky_n_it=sky_n_list.begin();sky_n_it!=sky_n_list.end();sky_n_it++){
					distance.SetVector(sky_n_it->fvPosition.fX-shot_it->fvPosition.fX,
						sky_n_it->fvPosition.fY-shot_it->fvPosition.fY);
					if(fabs(distance.CalcLength())<ShotData.fFindEnemyRange &&
					sky_n_it->IsDestroyable()){
						bLockedOn=true;
						target=sky_n_it->fvPosition;
						break;
					}
				}
			}
			//check locked on?
			if(!bLockedOn){
				for(g_e_it=g_e_list.begin();g_e_it!=g_e_list.end();g_e_it++){
					distance.SetVector(g_e_it->fvPosition.fX-shot_it->fvPosition.fX,
						g_e_it->fvPosition.fY-shot_it->fvPosition.fY);
					if(fabs(distance.CalcLength())<ShotData.fFindEnemyRange &&
					g_e_it->IsDestroyable()){
						bLockedOn=true;
						target=g_e_it->fvPosition;
						break;
					}
				}
			}
			//check locked on?
			if(!bLockedOn){
				for(g_n_it=g_n_list.begin();g_n_it!=g_n_list.end();g_n_it++){
					distance.SetVector(g_n_it->fvPosition.fX-shot_it->fvPosition.fX,
						g_n_it->fvPosition.fY-shot_it->fvPosition.fY);
					if(fabs(distance.CalcLength())<ShotData.fFindEnemyRange &&
					g_n_it->IsDestroyable()){
						bLockedOn=true;
						target=g_n_it->fvPosition;
						break;
					}
				}
			}
			//if there are no targets,set target to out of stage
			if(!bLockedOn)target.SetVector(-100,-100);
		}

		shot_it->Move(target);

		if(!shot_it->IsAlive()){
			shot_it=p_shot_list.erase(shot_it);
		}else{
			shot_it++;
		}

	}

}

/********************************
*		update enemies' shots	*
********************************/
void CGame::EnemyShotUpdate(void){
	for(std::list<CShot>::iterator it=e_shot_list.begin();
			it!=e_shot_list.end();){
		if(!it->IsAlive())continue;
		//	@Ƃ̓蔻
		if(it->IsHit(player) && it->IsHittable() && player.IsAlive()){
			//`[g[h̏̓vC[ɔC
			it->Hit();
			player.Hit();
		}
		it->Move(player.fvPosition);

		if(!it->IsAlive()){
			it=e_shot_list.erase(it);
		}else{
			it++;
		}
	}
}


/********************************
*		update items	*
********************************/
void CGame::ItemUpdate(){
	for(std::list<CItem>::iterator it=item_list.begin();
			it!=item_list.end();){
		//ړƍXV
		it->Move();

		//@Ƃ̓蔻
		if(it->IsHit(player)){
			it->Hit(&player);
		}
		if(!it->IsAlive()){
			it=item_list.erase(it);
		}else{
			it++;
		}
	}
}

/*******************************
	G̃Abvf[g
*******************************/
int CGame::SkyEnemyUpdate(void){
	int reply=0;
	
	for(std::list<CSkyEnemy>::iterator it=sky_e_list.begin();
			it!=sky_e_list.end();){
			//	ړAXV̂łɒe
		int command=it->Move(player.fvPosition);
		if(GameData.frStageRange.IsPointInRect(it->fvPosition)){
			it->Shot(player.fvPosition,command);
		}

		//	GƎ@̓蔻
		if(it->IsHittable() && it->IsHit(player) && player.IsAlive()
			&& !player.bGameOver){
			//`[g[h̗L̓vC[ŏ
			player.Hit();
			it->Hit(PlayerData.fPlayerHitPower,
				player.fvPosition);
		}
		if(!it->IsAlive()){
			if(it->GetEnemyType()==E_GODDESS_02_ ||
				it->GetEnemyType()==E_SHIVA_06_){
				reply=1;
			}
			it=sky_e_list.erase(it);
		}else{
			it++;
		}
	}
	return reply;

}

void CGame::SkyNeutralUpdate(void){
	for(std::list<CSkyNeutral>::iterator it=sky_n_list.begin();
			it!=sky_n_list.end();){
			//	ړAXV̂łɒe
		it->Move();

		//	GƎ@̓蔻
		if(it->IsHittable() && it->IsHit(player) && player.IsAlive()
			&& !player.bGameOver){
			//`[g[h̗L̓vC[ŏ
			player.Hit();
			it->Hit(PlayerData.fPlayerHitPower);
		}
		if(!it->IsAlive()){
			it=sky_n_list.erase(it);
		}else{
			it++;
		}
		
	}
}

int CGame::GEnemyUpdate(float scroll_speed){
	int reply=0;

	for(std::list<CGEnemy>::iterator it=g_e_list.begin();
			it!=g_e_list.end();){
			//	ړAXV̂łɒe
		int command=it->Move(player.fvPosition,scroll_speed);
		if(GameData.frStageRange.IsPointInRect(it->fvPosition)){
			it->Shot(player.fvPosition,command);
		}
		if(!it->IsAlive()){
			if(it->GetEnemyType()>=E_BOSS_02_ &&
				it->GetEnemyType()<=E_GATE_04_){
				reply=1;
			}
			it=g_e_list.erase(it);
		}else{
			it++;
		}
	}
	return reply;

}

void CGame::GNeutralUpdate(float scroll_speed){
	for(std::list<CGNeutral>::iterator it=g_n_list.begin();
			it!=g_n_list.end();){
			//	ړAXV̂łɒe
		it->Move(scroll_speed);
		if(!it->IsAlive()){
			it=g_n_list.erase(it);
		}else{
			it++;
		}
	}
}

void CGame::PieceUpdate(void){
	for(std::list<CPiece>::iterator it=piece_list.begin();
			it!=piece_list.end();){
		it->Move();
		if(!it->IsAlive()){
			it=piece_list.erase(it);
		}else{
			it++;
		}
	}
}

void CGame::ExpUpdate(float scroll_speed){
	for(std::list<CExp>::iterator it=exp_list.begin();
			it!=exp_list.end();){
		it->Move(scroll_speed);
		if(!it->IsAlive()){
			it=exp_list.erase(it);
		}else{
			it++;
		}
	}
}

void CGame::SmokeUpdate(void){
	for(std::list<CSmoke>::iterator it=smoke_list.begin();
			it!=smoke_list.end();){
		it->Move();
		if(!it->IsAlive()){
			it=smoke_list.erase(it);
		}else{
			it++;
		}
	}
}

void CGame::BGUpdate(float scroll_speed){
	for(std::list<CBG>::iterator it=bg_list.begin();
			it!=bg_list.end();){
		it->Move(scroll_speed);
		if(!it->IsAlive()){
			it=bg_list.erase(it);
		}else{
			it++;
		}
	}
}

/*----------------------------------*
	IuWFNg
	킴킴Ȃ̂pӂ̂
	NbVĔėp邽
	AI
*----------------------------------*/
void CGame::CreateObject(int listtype,int type,Vector2<float> pos0,
	Vector2<float> dir0,float speed_div)
{
	switch(listtype){
	case LIST_SKY_ENEMY_:
		CreateObjectTemplate(type,pos0,dir0,speed_div,&sky_e_list);
		break;
	case LIST_SKY_NEUTRAL_:
		CreateObjectTemplate(type,pos0,dir0,speed_div,&sky_n_list);
		break;
	case LIST_G_ENEMY_:
		CreateObjectTemplate(type,pos0,dir0,speed_div,&g_e_list);
		break;
	case LIST_G_NEUTRAL_:
		CreateObjectTemplate(type,pos0,dir0,speed_div,&g_n_list);
		break;

	case LIST_P_SHOT_:
		CreateObjectTemplate(type,pos0,dir0,speed_div,&p_shot_list);
		break;
	case LIST_E_SHOT_:
		CreateObjectTemplate(type,pos0,dir0,speed_div,&e_shot_list);
		break;

	case LIST_PIECE_:
		CreateObjectTemplate(type,pos0,dir0,speed_div,&piece_list);
		break;
	case LIST_EXP_:
		CreateObjectTemplate(type,pos0,dir0,speed_div,&exp_list);
		break;
	case LIST_SMOKE_:
		CreateObjectTemplate(type,pos0,dir0,speed_div,&smoke_list);
		break;
	case LIST_ITEM_:
		CreateObjectTemplate(type,pos0,dir0,speed_div,&item_list);
		break;
	case LIST_BG_:
		CreateObjectTemplate(type,pos0,dir0,speed_div,&bg_list);
		break;
	case LIST_SCORE_:
		CreateObjectTemplate(type,pos0,dir0,speed_div,&score_list);
		break;

	default:
		fprintf(stderr,"Invalid LIST type\n");
		exit(-1);
	}

}

/*
	draw curtain

	where_to_draw	0:StageRange
					1:Screen
*/
void CGame::DrawCurtain(int curtain_alpha,CozyRect curtain_src,
				 int where_to_draw){
	SDL_SetAlpha(sPat1,SDL_SRCALPHA, (Uint8)(curtain_alpha));
	Vector2<float> base_offset;
	Vector2<float> tile_range;

	if(where_to_draw==0){
		base_offset.SetVector(GameData.frStageRange.fX,GameData.frStageRange.fY);
		tile_range.SetVector(GameData.frStageRange.fWidth/curtain_src.fWidth,
			GameData.frStageRange.fHeight/curtain_src.fHeight);
	}else{
		base_offset.SetVector(0,0);
		tile_range.SetVector(GameData.fvScreenSize.fX/curtain_src.fWidth,
			GameData.fvScreenSize.fX/curtain_src.fHeight);
	}

	for(int i=0;i<tile_range.fX;i++){
		for(int j=0;j<tile_range.fY;j++){
			CObject::DrawLT(Vector2<float>::GetVector(
				i*curtain_src.fWidth+base_offset.fX,
				j*curtain_src.fHeight+base_offset.fY),
				curtain_src,sPat1,SDLSet.sScreen);
		}
	}
	SDL_SetAlpha(sPat1,SDL_SRCALPHA, (Uint8)(255));

}

//	draw shadow
void CGame::DrawShadow(){
	Vector2<float> shadow_pos;

	SDL_SetAlpha(sPat2,SDL_SRCALPHA, (Uint8)(50));

	shadow_pos.SetVector(20,20);
	// player's shadow
	if(player.IsAlive()){
		shadow_pos.AddVector(player.fvPosition);
		CObject::Draw(shadow_pos,CozyRect::GetRect(96,480,32,32),
			sPat2,SDLSet.sScreen);
	}

	CozyRect src;
	//sky enemies' shadow
	src.SetRect(0,480,32,32);
	int type;
	for(std::list<CSkyEnemy>::iterator sky_e_it=sky_e_list.begin();
	sky_e_it!=sky_e_list.end();sky_e_it++){
		shadow_pos.SetVector(20,20);
		shadow_pos.AddVector(sky_e_it->fvPosition);
		switch(sky_e_it->GetEnemyType()){
		case E_TURTLE_:
			src.fX=224;
			break;
		case E_BIG_BORT_:case E_BIG_BORT_DUAL_:
			src.fX=192;
			break;
		case E_HORMING_:case E_MISSILE_:case E_SLIM_MISSILE_:

			src.fX=0;
			break;
		case E_MANJYU_:case E_FAT_MISSILE_:case E_BULLET_MISSILE_:
			src.fX=32;
			break;
		case E_SKY_DUMMY_01:case E_SKY_DUMMY_GENERATOR_:
			src.fWidth=0;
			break;
		default:
			src.fX=96;
		}
		type=sky_e_it->GetEnemyType();
		if(type!=E_SKY_DUMMY_01 && !(type>=E_SKY_DUMMY_GENERATOR_ &&
			type<=E_HELI_04_GENERATOR_))
			CObject::Draw(shadow_pos,src,sPat2,SDLSet.sScreen);
	}
	//sky neutrals' shadow
	src.SetRect(0,480,32,32);
	for(std::list<CSkyNeutral>::iterator sky_n_it=sky_n_list.begin();
	sky_n_it!=sky_n_list.end();sky_n_it++){
		shadow_pos.SetVector(20,20);
		shadow_pos.AddVector(sky_e_it->fvPosition);
		switch(sky_n_it->GetEnemyType()){
		case E_TURTLE_:
			src.fX=224;
			break;
		case E_BIG_BORT_:case E_BIG_BORT_DUAL_:
			src.fX=192;
			break;
		default:
			//\ȂB
			src.fX=256;
		}
		CObject::Draw(shadow_pos,src,sPat2,SDLSet.sScreen);
	}

	//item's shadow
	for(std::list<CItem>::iterator item_it=item_list.begin();
	item_it!=item_list.end();item_it++){
		src.SetRect(0,480,32,32);
		shadow_pos.SetVector(20,20);
		shadow_pos.AddVector(item_it->fvPosition);
		CObject::Draw(shadow_pos,src,sPat2,SDLSet.sScreen);
	}
	SDL_SetAlpha(sPat2,SDL_SRCALPHA, (Uint8)(255));
}

void CGame::SkipStage(int skip){
	timer_manager.ResetNameListIterator();
	int i;
	for(i=0;i<skip;i++){
		//I}bv܂ŃXLbv
		timer_manager.NextMap();
	}
	nStage_=skip;
	if(skip==0){
		timer_manager.InputFirstMap();
	}
}

void CGame::DrawBossHP(float hp,float hp_max,int dan){
	Vector2<float> pos;
	CozyRect src;

	pos.SetVector(GameData.frStageRange.fX+GameData.frStageRange.fWidth/2.f,
		GameData.frStageRange.fY+20.f*dan);
	//g
	src.SetRect(0,256,400,16);
	CObject::Draw(pos,src,sPat3,SDLSet.sScreen);

	//̗͂ŕ\
	src.SetRect(0,272,400.f*(hp/hp_max),16);
	CObject::Draw(pos,src,sPat3,SDLSet.sScreen);

}
