/*
	1024:Re
*/
#include "stdafx.h"
#include "CMusic.h"

/*****************************************************
	[hs̏
IN:
	fname			ǂݍ݂Ɏst@C
	errSDLMessave	SDL󂯎G[bZ[W
*****************************************************/
void CMusic::LoadErrorResume(char *fname,char *errSDLMessage){
	fprintf(stderr, "Warning: Couldn't load music[%s]: %s\n",fname
						,errSDLMessage);
}

/*****************************************************
	~[WbNt@C̃[h
IN:
	fname		t@C
	ftype		t@C^Cviwb_[QƁj
	channel		wave^̏ꍇAǂ̃`lŖ炷(̃^CvȂ疳)
*****************************************************/
int CMusic::LoadFile(char *fname,int ftype,int channel){
	nMusicFileType=ftype;
	nWaveChannel=channel;
	
	switch(ftype){
	case MIDI_:case MOD_:
		mMusic = Mix_LoadMUS(fname);

		if ( mMusic == NULL ) {
			LoadErrorResume(fname,Mix_GetError());
			return -1;
		}
	case WAVE_:
		wavMusic = Mix_LoadWAV(fname);

		if ( wavMusic == NULL ) {
			LoadErrorResume(fname,Mix_GetError());
			return -1;
		}
	}
	return 0;
}

CMusic::~CMusic(){
	switch(nMusicFileType){
	case MIDI_:case MOD_:
		Mix_FreeMusic(mMusic);
		break;
	case WAVE_:
		Mix_FreeChunk(wavMusic);
		break;
	}
}

/********************************
	BGM̉tJn
********************************/
void CMusic::StartBGM(int loop){
	switch(nMusicFileType){
	case MIDI_:case MOD_:
		Mix_PlayMusic(mMusic, loop);
		break;
	case WAVE_:
		Mix_PlayChannel(nWaveChannel, wavMusic, loop);
		break;
	}
}

void CMusic::RestartBGM(int loop){
	StartBGM(loop);
}

/********************************
	BGM̒~
********************************/
void CMusic::StopBGM(){
	switch(nMusicFileType){
	case MIDI_:case MOD_:
		if ( Mix_PlayingMusic() ) {
			Mix_HaltMusic();
		}
		break;
	case WAVE_:
		if ( Mix_Playing(nWaveChannel) ) {
			Mix_HaltChannel(-1);
		}
	}
}

void CMusic::CheckAndLoop(void){
	if(!CheckPlaying())
		StartBGM(-1);
}

//
bool CMusic::CheckPlaying(void){
	switch(nMusicFileType){
	case MOD_:
	case MIDI_:
		if(!Mix_PlayingMusic())
			return false;
		else return true;
		break;
	case WAVE_:
		if(!Mix_Playing(nWaveChannel))
			return false;
		else return true;
		break;
	}
	return true;
}
