#include "stdafx.h"
#include "CShot.h"
#include "CGame.h"

extern CGame game;

/**************************/
//	ʐݒ
/**************************/
void CShot::CommonInit(int type){
	nShotType=type;
	bHittable=true;

	//	things that must be set inner
	Data.nCounter=0;
	Data.nTurn=0;

	//radiation's default is set to player's shot's one
	float r;
	r=ShotData.fPShotRadiation;

	//	individual
	CozyRect src;
	float speed,power;
	switch(type){
	case SMALL_SHOT_:
		src=ShotData.frSmallShotSrc;
		r=ShotData.fSmallShotRadiation;
		speed=ShotData.fSmallShotSpeed;
		break;
	case MIDIUM_SHOT_:	//very yellow shot(fastest)
		src=ShotData.frMidiumShotSrc;
		r=ShotData.fMidiumShotRadiation;
		speed=ShotData.fMidiumShotSpeed;
		break;
	case MIDIUM_SHOT_S_:	//shot that has 8 direction's sources
		src=ShotData.frMidiumShotSSrc;
		r=ShotData.fMidiumShotRadiation;	//co-use radiation
		speed=ShotData.fMidiumShotSSpeed;
		break;
	case LARGE_SHOT_:
		//Vbg̃TEh
		game.se[WAV_ENEMY_LARGE_SHOT_].Play();

		src=ShotData.frLargeShotSrc;
		r=ShotData.fLargeShotRadiation;
		speed=ShotData.fLargeShotSpeed;
		break;
	case GRAVITY_SHOT_:	//'that' shot
		src=ShotData.frGravityShotSrc;
		r=ShotData.fGravityShotRadiation;
		speed=ShotData.fGravityShotSpeed;

		Data.animeID=CAnime(4,2);
		break;

	case P_BALKAN_SHOT_:
		src=ShotData.frPBalkanShotSrc;
		speed=ShotData.fBalkanSpeed;
		power=ShotData.fBalkanPower;
		break;
	case P_BALKAN_MAX_SHOT_:
		src=ShotData.frPBalkanMaxShotSrc;
		speed=ShotData.fBalkanSpeed;
		power=ShotData.fBalkanPower*ShotData.fBalkanMaxDiv;
		break;
	case P_KAKUSAN_SHOT_:
		src=ShotData.frPKakusanShotSrc;
		speed=ShotData.fKakusanSpeed;
		power=ShotData.fKakusanPower;
		break;
	case P_KAKUSAN_MAX_SHOT_:
		src=ShotData.frPKakusanMaxShotSrc;
		speed=ShotData.fKakusanSpeed;
		power=ShotData.fKakusanPower*ShotData.fKakusanMaxDiv;
		break;
	case P_LASER_SHOT_:
		src=ShotData.frPLaserShotSrc;
		speed=ShotData.fLaserSpeed;
		power=ShotData.fLaserPower;
		break;
	case P_LASER_MAX_SHOT_:
		src=ShotData.frPLaserMaxShotSrc;
		speed=ShotData.fLaserSpeed;
		power=ShotData.fLaserPower*ShotData.fLaserMaxDiv;

		Data.fFirstPositionX=fvPosition.fX;
		break;
	case P_HOMING_SHOT_:
		src=ShotData.frPHomingShotSrc;
		speed=ShotData.fPHomingSpeed;
		power=ShotData.fPHomingPower;
		break;
	case P_MISSILE_SHOT_:
		src=ShotData.frPMissileShotSrc;
		speed=ShotData.fPMissileSpeed;
		power=ShotData.fPMissilePower;
		break;

	case P_BOMB_SHOT_:
		game.se[WAV_BCG9001_].Play();
		src=ShotData.frPBombShotSrc;
		speed=ShotData.fPBombSpeed;
		power=ShotData.fPBombPower;
		r=ShotData.fPBombRadiation;
		Data.fInterval=0;
		break;

	//------------------
	//Durandal's special shot
	case DUAL_HUGE_SHOT_SHOOTER_:
	case DUAL_HUGE_SHOT_:	//how is this huge!
		//Vbg̃TEh
		game.se[WAV_ENEMY_HUGE_SHOT_].Play();

		Data.fInterval=ShotData.fDuanHugeShotInterval;
		src=ShotData.frDualHugeShotSrc;
		r=ShotData.fDualHugeShotRadiation;
		speed=ShotData.fDualHugeShotSpeed;
		break;

	case NEEDLE_SHOT_:
		src=ShotData.frNeedleShotSrc;
		r=ShotData.fNeedleShotRadiation;
		speed=ShotData.fNeedleShotSpeed;
		break;

	case ENEMY_LASER_SHOT_:
		src=ShotData.frEnemyLaserShotSrc;
		src.fX=ShotData.frEnemyLaserShotSrc.fX+
			ShotData.frEnemyLaserShotSrc.fWidth/2.f;
		src.fWidth=0;
		r=ShotData.fEnemyLaserShotRadiation;
		speed=ShotData.fEnemyLaserShotSpeed;
		break;
	}

	frSrcRect=src;
	fSpeed=speed;
	Data.fPower=power;
	fRadiation=r;

	//xɉp[iGdȂ悤Ɍj
	if(nShotType>=P_BALKAN_SHOT_ && nShotType<=P_BOMB_SHOT_){
		Data.fPower*=(100.f-ShotData.fPShotWeakRate*(GameData.nLevel-1))/100.f;
		Data.fMaxPower=Data.fPower;
	}
}

/**************************/
//	Constructor
/**************************/
//type,pos0,dir0
CShot::CShot(int type,Vector2<float> pos0,Vector2<float> dir0)
:CObject(SHOT_,pos0,dir0,0,0){
	CommonInit(type);
}

/************************/
/*		Move or Update		*/
/************************/
void CShot::Move(Vector2<float> target_pos){
	float dx,dy;
	Vector2<float> dir;//,dir2;
	Vector2<float> temp_pos,temp_dir;
	float temp_angle;
//	int i;

	dx=target_pos.fX-fvPosition.fX;
	dy=target_pos.fY-fvPosition.fY;

	//Make AIM from Target_position
	Vector2<float> aim=Vector2<float>(dx,dy);

	Data.nCounter++;

	switch(nShotType){
	case SMALL_SHOT_:
	case MIDIUM_SHOT_:
		break;
	case MIDIUM_SHOT_S_:
		//change source's rect by direction
		frSrcRect.fX=32.f*8.f+
			16.f*((fvDirection.ChangeDirectionN(16)+4)%16);
		break;
	case LARGE_SHOT_:
	case DUAL_HUGE_SHOT_:
		break;
	case DUAL_HUGE_SHOT_SHOOTER_:
		if(Data.nCounter%(int)(Data.fInterval)==0){
//			for(i=0;i<GameData.nLevel;i++){
				temp_dir.AngleToVector(RandomDegreeToRadian(0,360));
				game.CreateObject(LIST_E_SHOT_,LARGE_SHOT_,
					fvPosition,temp_dir);
//			}
		}
		break;
	case GRAVITY_SHOT_:
		if(Data.nTurn==0){
			//only first time
			fvDirection.Expand(fSpeed);
			Data.nTurn=1;
		}
		//change source
		Data.animeID.Execute();
		frSrcRect.fX=ShotData.frGravityShotSrc.fX+16*Data.animeID.GetID();
		//gravity(this doesn't use BasicMove()
		//y=1/2gt^2+v0t
		dir.SetVector(0,5.f);
		dir.Expand(ShotData.fGravityShotAccel);
		fvDirection.AddVector(dir);
		fvPosition.AddVector(fvDirection);
		break;

	case P_BALKAN_SHOT_:
	case P_BALKAN_MAX_SHOT_:
	case P_KAKUSAN_SHOT_:
	case P_KAKUSAN_MAX_SHOT_:
		break;
	case P_LASER_SHOT_:
		fvPosition.fX=target_pos.fX;
		break;
	case P_LASER_MAX_SHOT_:
		fvPosition.fX=target_pos.fX;
		fvPosition.fX+=Data.fFirstPositionX;
		break;
	case ENEMY_LASER_SHOT_:
		//˂u
//		fvPosition.fX=target_pos.fX;
		//̑
//		exit(-1);
		if(Data.nTurn==0){
			frSrcRect.fX-=ShotData.fEnemyLaserShotEnlargingSpeed/2.f;
			frSrcRect.fWidth+=ShotData.fEnemyLaserShotEnlargingSpeed;
			if(frSrcRect.fWidth>ShotData.frEnemyLaserShotSrc.fWidth){
				frSrcRect.fX=ShotData.frEnemyLaserShotSrc.fX;
				frSrcRect.fWidth=ShotData.frEnemyLaserShotSrc.fWidth;
				Data.nTurn=1;
				Data.nCounter=0;
			}
		}else{
			if(Data.nCounter>ShotData.fEnemyLaserShotLivingTimeAfterLargest){
				bAlive=false;
			}
		}
		break;
	case P_HOMING_SHOT_:
		frSrcRect.fX=256.f+
			16.f*((fvDirection.ChangeDirectionN(8)+2)%8);

		//homing only if target is in StageRange
		if(GameData.frStageRange.IsPointInRect(target_pos)){
			fvDirection.DirectHomingTarget(target_pos,fvPosition);
		}else{
			//fSpeed=ShotData.fPHomingSpeed;
		}

		//if this move too fast,speed down
		if(fSpeed>ShotData.fSmallShotSpeed){
			fSpeed-=fSpeed*(80.f/100.f);
		}
		break;
	case P_MISSILE_SHOT_:
		if(fvDirection.fY>-ShotData.fPMissileSpeed*1){
			dir.SetVector(0,-ShotData.fPMissileAccel);
			fvDirection.AddVector(dir);
		}
		break;
	case P_BOMB_SHOT_:
		Data.fInterval+=DegreeToRadian(60);
		if(Data.fInterval>DegreeToRadian(360))Data.fInterval=0;
		for(temp_angle=Data.fInterval;temp_angle<Data.fInterval+fCOZY_PAI*2;temp_angle+=DegreeToRadian(30)){
			temp_pos.AngleToVector(temp_angle);
			temp_pos.Expand(Randomize(100,200));
			temp_pos.AddVector(fvPosition);
			game.CreateObject(LIST_EXP_,NO_SOUND_SKY_EXP_,temp_pos);
		}
		fSpeed+=ShotData.fPBombAccel;
		break;
	case NEEDLE_SHOT_:
		//i
		break;
	}

	if(nShotType!=GRAVITY_SHOT_)BasicMove();

	//vC[Vbg̓Xe[WOŏŁBĜ͌E܂Ŏc
	if((nShotType>=P_BALKAN_SHOT_ && nShotType<=P_BOMB_SHOT_ )||
		nShotType==NEEDLE_SHOT_){
		if(!CheckStage())bAlive=false;
	}else{
		if(!CheckSeekable())bAlive=false;
	}

	//j͌
	if(nShotType>=P_BALKAN_SHOT_ && nShotType<=P_BOMB_SHOT_){
		if(Data.fPower>Data.fMaxPower/2.f)Data.fPower-=0.5f;
	}

}

/**************************************************************
			NWayVbg
	n̒Vbg𐶐
	n:						SeБƂ̂ł͂ȂS
	pos0:					˂̒Sʒu
	angle:					^񒆂̔˕
	interval_angle:			̊pxԊu
	r:						ˏʒuŒS̋
	dest_pos[],dest_dir[]:	o͏oオʒuƏB
							̂܂Createɕ荞߂΂悢

	OUTPUT:s͕̐Ԃ
		n<=0̂Ƃs
**************************************************************/
int CShot::NWayShot(int n,Vector2<float> pos0,float angle,float interval_angle,
					float r,Vector2<float> *dest_pos,
					Vector2<float> *dest_dir/*vector<Vector2<float> > &dest_pos,
					vector<Vector2<float> > &dest_dir*/){
	if(n<=0)return -1;
	float aim;
	int counter=0;

	if(n%2==1){
		//Ȃ璼ڂ̂̂
		dest_pos[counter].SetVector(pos0.fX+r*(float)cos(angle),
			pos0.fY+r*(float)sin(angle));
		dest_dir[counter].SetVector((float)cos(angle),(float)sin(angle));
		counter++;
	}

	for(float i=((n%2==1)?1:0.5);i<((n%2==1)?((int)(n/2)+1):(n/2+1));i++){
		//E
		aim=angle+interval_angle*i;

		dest_pos[counter].SetVector(pos0.fX+r*(float)cos(aim),
			pos0.fY+r*(float)sin(aim));
		dest_dir[counter].SetVector((float)cos(aim),(float)sin(aim));
		counter++;

		//
		aim=angle-interval_angle*i;

		dest_pos[counter].SetVector(pos0.fX+r*(float)cos(aim),
			pos0.fY+r*(float)sin(aim));
		dest_dir[counter].SetVector((float)cos(aim),(float)sin(aim));
		counter++;
	}

	return 0;
}

/**************************************************************
*	p[^ɂĕϑIɕωgUe	*
	pos0:	ʒu(Sʒu)
	speed:	Wx
	angle:	ˊpx
	po:		KlBΏۂւ̕ɋ߂̂قǂɋ߂KƂȂB
	par:	䗦B̂܂܂ł͑߂x肷̂ŁA
			Ő䂷Bpô݂ƑGc߂B
	min:	ŏxBvZɂĂ0ɂȂ邱Ƃ悭̂ŁA
			ʏɎcȂǂƂT̂hB
	step:	px̊Ԋu
	dest_*:	óB肩łȂ̂ŁA߂ɊmۂĂA
			vZŌoĂĂǂB(2΂stepŊ邾)
			O҂ȂAȂׂgp͊JĂ

	OUTPUT:	ُ펞ɂ͕̒lfpar܂ɏ(0͘_O)ςȐlɂȂ̂
			Ă炢܂
***************************************************************/
int CShot::ExplodeShot(Vector2<float> pos0,float speed,float angle,
					   float po,float par,float min,float step,
					   /*Vector2 *dest_pos,*/Vector2<float> *dest_dir,
					   float *dest_speed){
	//	angle:ڕWւ̎̕p
	//	po,par,min:p[^

	Vector2<float> aim;	aim.AngleToVector(angle);
	Vector2<float> dir;

	aim.Expand(po);
	int counter=0;

	if(fabs(par)<0.001f)
	for(float theta=0.f;theta<fCOZY_PAI*2;theta+=step){
		dir.AngleToVector(theta);
		dir.AddVector(aim);

		dest_speed[counter]=
			(float)(speed*pow((double)(dir.CalcLength()/par),
			po)+min);
//		dest_pos[counter]
		dest_dir[counter]=dir;
		counter++;
	}
	return 0;
}

/************************/
/*		R`g			*/
/************************/
int CShot::ArrowShot(Vector2<float> pos0,float dis,float interval,
		float theta,float angle,int n,Vector2<float> *dest_pos,
		Vector2<float> *dest_dir){
	int counter=0;
	if(n<=0)return -1;

	float costh=(float)cos(angle),sinth=(float)sin(angle);
	float costh2=(float)cos(angle-fCOZY_PAI/2.f);
	float sinth2=(float)sin(angle-fCOZY_PAI/2.f);
	float tanth=(float)tan(theta+fCOZY_PAI/2.f);
	dest_pos[counter].SetVector(0,dis);
	dest_dir[counter].SetVector(costh,sinth);
	counter++;

	int i;
	for(i=1;i<n;i++){
		float x=interval*i,y;
		y=tanth*x+dis;

		dest_pos[counter].SetVector(x,y);
		dest_dir[counter].SetVector(costh,sinth);
		counter++;
		dest_pos[counter].SetVector(-x,y);
		dest_dir[counter].SetVector(costh,sinth);
		counter++;
	}
	//	]yуXN[ւ̕sړ
	for(i=0;i<counter;i++){
		float ox=dest_pos[i].fX;
		float oy=dest_pos[i].fY;
		dest_pos[i].fX=ox*costh2-oy*sinth2+pos0.fX;
		dest_pos[i].fY=ox*sinth2+oy*costh2+pos0.fY;
	}
	return 0;
}

////////////////////////////////////////////////////////
/****************************/
/*	ǂ̂	*/
/****************************/
void CShot::Hit(){
	if(nShotType!=P_BOMB_SHOT_ && nShotType!=P_BALKAN_MAX_SHOT_ &&
		nShotType!=ENEMY_LASER_SHOT_)
		bAlive=false;
	//	ʂ̔?
	//
	int i;

	if(GameData.frStageRange.IsPointInRect(fvPosition)){
		if(nShotType<P_BALKAN_SHOT_ || nShotType>P_BOMB_SHOT_){
			game.CreateObject(LIST_EXP_,SKY_EXP_,fvPosition);
			//ꍇɂĂ(switch)
		}else{
			for(i=0;i<rand()%(PieceData.nMax-PieceData.nMin)+PieceData.nMin;i++){
				game.CreateObject(LIST_PIECE_,HIT_PIECE_,fvPosition);
			}
		}
	}
}

/****************************/
//ʂȕ\
/****************************/
void CShot::DrawSP(SDL_Surface *pat1,SDL_Surface *pat2,SDL_Surface *pat3,SDL_Surface *dest){
	if(nShotType==DUAL_HUGE_SHOT_ || nShotType==DUAL_HUGE_SHOT_SHOOTER_){
		SDL_SetAlpha(pat2,SDL_SRCALPHA, (Uint8)(120));
		Draw(pat2,dest);
		SDL_SetAlpha(pat2,SDL_SRCALPHA, (Uint8)(255));
	}else if(nShotType==NEEDLE_SHOT_){
//		RotZoomDraw(pat3,dest,RadianToDegree(fvDirection.VectorToAngle()),
//			3,0.5);
//		RotZoomDraw(pat3,dest,fvDirection.VectorToAngle(),
//			3,0.5);
	}else if(nShotType==ENEMY_LASER_SHOT_){
		SDL_SetAlpha(pat3,SDL_SRCALPHA, (Uint8)(120));
		Draw(pat3,dest);
		SDL_SetAlpha(pat3,SDL_SRCALPHA, (Uint8)(255));
		//`ŕ
		SDL_Rect r;
		r.x=fvPosition.fX-frSrcRect.fWidth/2.f;
		r.y=fvPosition.fY-frSrcRect.fHeight/2.f;
		r.w=frSrcRect.fWidth;
		r.h=frSrcRect.fHeight;
//		Uint32 col=SDL_MapRGBA(dest->format,255,255,255,
//			25+200*sin(DegreeToRadian(Data.nCounter)));
		boxRGBA(dest,r.x,r.y,r.x+r.w,r.y+r.h,255,255,255,
			25+200*sin(DegreeToRadian(Data.nCounter*20)));
		//SDL_FillRect(dest,&r,col);
	}else{
		if(nShotType>=P_BALKAN_SHOT_ && nShotType<=P_MISSILE_SHOT_)
			SDL_SetAlpha(pat1,SDL_SRCALPHA, (Uint8)(200));
		Draw(pat1,dest);
		if(nShotType>=P_BALKAN_SHOT_ && nShotType<=P_MISSILE_SHOT_)
			SDL_SetAlpha(pat1,SDL_SRCALPHA, (Uint8)(255));
	}
}

/****************************
	Az}[N1
	r				:ő唼a
	interval_dig	:xɒezu邩B
	͑ŜłPɌ肷B
****************************/
int CShot::OnmyouShot(Vector2<float> pos0,Vector2<float> dir0,
	float r,float interval_dig,Vector2<float> *dest_pos,
	Vector2<float> *dest_dir,int check_num){

	float half_r=r/2.f;
	float fA,fDelta=DegreeToRadian(interval_dig);

	int nCounter=0;
	int i;

	//O
	for(fA=0;fA<=DegreeToRadian(360);fA+=fDelta){
		dest_pos[nCounter].AngleToVector(fA);
		dest_pos[nCounter].Expand(r);
		dest_pos[nCounter].AddVector(pos0);
		dest_dir[nCounter]=dir0;
		nCounter++;
		if(nCounter>=check_num)return -1;
	}

	Vector2<float> center;
	//̏Ȕ~
	//Ԋu͔{ł悢
	for(i=0;i<2;i++){
		center.SetVector((i*2-1)*half_r,0);
		center.AddVector(pos0);

		dest_pos[nCounter]=center;
		dest_dir[nCounter]=dir0;
		nCounter++;
		if(nCounter>=check_num)return -1;

		for(fA=DegreeToRadian(i*180);fA<=DegreeToRadian(180+i*180);fA+=fDelta*2){
			dest_pos[nCounter].AngleToVector(fA);
			dest_pos[nCounter].Expand(half_r);
			dest_pos[nCounter].AddVector(center);
			dest_dir[nCounter]=dir0;
			nCounter++;
			if(nCounter>=check_num)return -1;
		}
	}
	return nCounter;
}

//̂̂ƓAPP𒆐SO֌ɐݒ肷B
int CShot::OnmyouShot(Vector2<float> pos0,
	float r,float interval_dig,Vector2<float> *dest_pos,
	Vector2<float> *dest_dir,int check_num,float *dest_speed_div){

	float half_r=r/2.f;
	float fA,fDelta=DegreeToRadian(interval_dig);

	int nCounter=0;
	int i;

	//O
	for(fA=0;fA<=DegreeToRadian(360);fA+=fDelta){
		dest_pos[nCounter].AngleToVector(fA);
		dest_pos[nCounter].Expand(r);

        dest_speed_div[nCounter]=1;

		dest_pos[nCounter].AddVector(pos0);
        //͏L̂̂Ƃ͈ႤB
		dest_dir[nCounter].SetVector(dest_pos[nCounter].fX-pos0.fX,dest_pos[nCounter].fY-pos0.fY);
		dest_dir[nCounter].Former();
		nCounter++;
		if(nCounter>=check_num)return -1;
	}

	Vector2<float> center;
	//̏Ȕ~
	//Ԋu͔{ł悢
	for(i=0;i<2;i++){
		center.SetVector((i*2-1)*half_r,0);
		center.AddVector(pos0);

        //S
		dest_pos[nCounter]=center;

        dest_speed_div[nCounter]=dest_pos[nCounter].CalcLength()/r;

		dest_dir[nCounter].SetVector(dest_pos[nCounter].fX-pos0.fX,dest_pos[nCounter].fY-pos0.fY);
		dest_dir[nCounter].Former();

		nCounter++;
		if(nCounter>=check_num)return -1;

		//̒e̔zu
        for(fA=DegreeToRadian(i*180);fA<=DegreeToRadian(180+i*180);fA+=fDelta*2){
			dest_pos[nCounter].AngleToVector(fA);
			dest_pos[nCounter].Expand(half_r);

	        dest_speed_div[nCounter]=dest_pos[nCounter].CalcLength()/r;

			dest_pos[nCounter].AddVector(center);

			dest_dir[nCounter].SetVector(dest_pos[nCounter].fX-pos0.fX,dest_pos[nCounter].fY-pos0.fY);
			dest_dir[nCounter].Former();
			if(dest_dir[nCounter].CalcLength()==0){
				dest_dir[nCounter].SetVector(1.f,0);
	            dest_speed_div[nCounter]=1;
			}
			nCounter++;
			if(nCounter>=check_num)return -1;
		}
	}
	return nCounter;
}

/*
	sVbg
	@distance	:pos0̋BȂdir0ցB
		Ȃdir0̋tւ炷B
*/
int CShot::ParallelShot(Vector2<float> pos0,
	    Vector2<float> dir0,int n,float distance,
	    float interval,
	    Vector2<float> *dest_pos,
		Vector2<float> *dest_dir){
	//dir0ɑ΂ĐȃxNgverticp
    Vector2<float> vertic;
    vertic.SetVector(dir0.fY,dir0.fX);
    vertic.Former();
    //PS.t͂ǂł

    //pos0ɑ΂distanceꂽAue̒SvxNgcentralp
    Vector2<float> central,temp_v;
    central=pos0;
    temp_v=dir0;
    temp_v.Expand(distance);
    central.AddVector(temp_v);

    int nCounter=0,i,j;

    if(n==0)return -1;
    if(n%2==1){
    	//̏ꍇ
        //	ɒS
        dest_pos[nCounter]=central;
        dest_dir[nCounter]=dir0;
        n--;
        nCounter++;

    	for(i=1;i<=n/2;i++){
        	for(j=-1;j<2;j+=2){//t
            	temp_v=vertic;
            	temp_v.Expand(j*interval*i);
	        	dest_pos[nCounter]=central;
            	dest_pos[nCounter].AddVector(temp_v);
	        	dest_dir[nCounter]=dir0;
        		nCounter++;
            }
        }
    }else{
    	//̏ꍇ
        //	S2̊Ԋuinterval*2ƂȂȂ悤ɒ
        for(i=0;i<n/2;i++){
        	for(j=-1;j<2;j+=2){//t
            	temp_v=vertic;
            	temp_v.Expand(j*interval*(i+0.5f));
	        	dest_pos[nCounter]=central;
            	dest_pos[nCounter].AddVector(temp_v);
	        	dest_dir[nCounter]=dir0;
        		nCounter++;
            }
        }
    }

    //I
    return 0;
}

