/*
	Class for Shots
*/

#ifndef _C_SHOT_H_
#define _C_SHOT_H_

/*---------------------------*/
//		Includes
/*---------------------------*/
#include "stdafx.h"
#include "CObject.h"

#include "CPiece.h"
#include "CExp.h"

#include "CAnime.h"

class CShot;
//typedef std::list<CShot> SHOT_LIST;
/********************/
//	Type of Shots(Enumeratation)
/********************/
enum{
	//Enemy's Shot
	SMALL_SHOT_=0,
	MIDIUM_SHOT_,
	MIDIUM_SHOT_S_,
	LARGE_SHOT_,
	GRAVITY_SHOT_,	//'that' shot

	//Player's shot
	P_BALKAN_SHOT_,
	P_BALKAN_MAX_SHOT_,
	P_KAKUSAN_SHOT_,
	P_KAKUSAN_MAX_SHOT_,
	P_LASER_SHOT_,
	P_LASER_MAX_SHOT_,//10
	P_HOMING_SHOT_,
	P_MISSILE_SHOT_,

	P_BOMB_SHOT_,

	//------------------
	DUAL_HUGE_SHOT_,
	DUAL_HUGE_SHOT_SHOOTER_,	//making L shots

	//new 4/29
	NEEDLE_SHOT_,	//gpi

	//5/4
	ENEMY_LASER_SHOT_,
//	ENEMY_LASER_SHOT_GUIDE_,	//ƒʂ܂iPȂ`łCj
	TURN_SHOT_01_,
};

/*---------------------------*/
//	Advanced struture ... ?why class?
/*---------------------------*/
/*typedef struct*/class ShotAdvancedData/*_tag*/{
public:
	ShotAdvancedData(){}
	int nCounter;		//Inner counter
	char nTurn;				//Now,what turn am I?
	float fPower;			//power of attack
	float fMaxPower;		//max_power
	float fAccel;			//accel or deaccel (leaf shot)
	float fTurnSpeed;	//turning speed of homing

	CAnime animeID;

	float fInterval;	//for some interval action

	bool bHitting;

	float fFirstPositionX;//Lv.5̃[U[Ŏgp

	//5/4
//	Vector2<float> fvDirectionAfterTurn;	//^[̌i΃WAj
};//ShotAdvancedData;

/*******************************/
//	VbgNX
/*******************************/
class CShot:public CObject{
private:
	int nShotType;
	void CommonInit(int type);
public:
	ShotAdvancedData Data;

	CShot(){bAlive=false;}
	~CShot(){
	}

	//Constructor
	CShot(int type,Vector2<float> pos0,Vector2<float> dir0);

	//get this shot's type
	int GetType(void){return nShotType;}

public:
	void Move(Vector2<float> target_pos);

	void Hit();

	//Special Draw
	void DrawSP(SDL_Surface *pat1,SDL_Surface *pat2,SDL_Surface *pat3,
		SDL_Surface *dest);
public:
	/////////////////////////////////////////////////////////////////
	//	Standard Shot Library

	//	create N-way shot's position & direction
	static int NWayShot(int n,Vector2<float> pos0,float angle,float interval_angle,
					float r,Vector2<float> *dest_pos,
					Vector2<float> *dest_dir/*vector<Vector2<float> > &dest_pos,
					vector<Vector2<float> > &dest_dir*/);

	//	p[^ɂĕϑIɕωgUe
	//		Ȍ`Aɂ̓n[g^ɂȂB
	//		x̕ωAɌ둤͔ɒxAc葱
	static int ExplodeShot(Vector2<float> pos0,float speed,float angle,
					   float po,float par,float min,float step,
					   Vector2<float> *dest_dir,
					   float *dest_speed);

	//	shots like arrow
	static int ArrowShot(Vector2<float> pos0,float dis,float interval,
		float theta,float angle,int n,Vector2<float> *dest_pos,
		Vector2<float> *dest_dir);

	/*
		Az}[N1
		r				:ő唼a
		interval_dig	:xɒezu邩B
		check_num		:̌xBvectorĝc

		Ԃl	:܂Ύgpϐ̌BsΕ̒lԂB
		͑ŜłPɌ肷B
	*/
	static int OnmyouShot(Vector2<float> pos0,Vector2<float> dir0,
		float r,float interval_dig,Vector2<float> *dest_pos,
		Vector2<float> *dest_dir,int check_num);

	//̂̂ƓAPP𒆐SO֌ɐݒ肷B
    //TODO
    //	@肭ȂBSɋ߂ÂقǑxɂ
    //	B
    //	  ȒŜ݂ŁA~܂Ȃ悤ɒӁB
    //	Ƃx̏o͂v邶I
	static int OnmyouShot(Vector2<float> pos0,
		float r,float interval_dig,Vector2<float> *dest_pos,
		Vector2<float> *dest_dir,int check_num,float *dest_speed_div);

	/*
    sVbgQ̍\
    	ɑ΂ĒpAԊuɔzu
    	gݍ킹heƂėpł

    n			:e
    distance	:pos0̋
    interval	:em̊Ԋu
    */
	static int ParallelShot(Vector2<float> pos0,
    	Vector2<float> dir0,int n,float distance,
        float interval,
        Vector2<float> *dest_pos,
		Vector2<float> *dest_dir);
	/////////////////////////////////////////////////////////////////
};
#endif
