/*********************************
	Q
	1101:ev[gB
*********************************/
#ifndef _VECTOR_2_H_
#define _VECTOR_2_H_
#include "CozyLib.h"
#include <math.h>

/*********************************************/
//	QNX
/*********************************************/
template <class T>class Vector2{
public :
	T fX,fY;

	/*-----------------
		RXgN^
	-----------------*/
	Vector2();
	Vector2(T x,T y){SetVector(x,y);}
	~Vector2(){}
	
	/*--------------------------------
		x,yxNg^ɕϊĎ擾
	--------------------------------*/
	static Vector2<T> GetVector(T x,T y){
		Vector2<T> v=Vector2<T>(x,y);
		return v;
	}
	/*-----------------
		ݒ
	-----------------*/
	void SetVector(T x,T y);
	/*--------------------------------
		K
	--------------------------------*/
	void Former(){
		T length=CalcLength();	//߂
		
		if(length==0)return;
		fX/=length;
		fY/=length;
	}
	/*--------------------------------
		߂
	--------------------------------*/
	T GetLength(void){return CalcLength(fX,fY);}
	T CalcLength(void){return CalcLength(fX,fY);}
	T GetLength(T x,T y){return CalcLength(x,y);}
	T CalcLength(T x,T y){return (T)(sqrt(y*y+x*x));}

	/*--------------------------------
		xNgpxɒ
	--------------------------------*/
	T VectorToAngle(void){
		T dx,dy,angle,fTan;

		dx=fX;
		dy=fY;
		if(fX==0)dx=0.0001f;
		fTan=dy/dx;

		if(fX<0.0f)
			return (T)(atan(fTan)+fCOZY_PAI);
		else{
			angle=(T)(atan(fTan));
			if(angle<0.0f)angle+=(T)2*fCOZY_PAI;
			return angle;
		}
	}
	static T VectorToAngle(Vector2 v);
	
	/*--------------------------------
		pxxNg
	--------------------------------*/
	void AngleToVector(T angle){
		SetVector((T)(cos(angle)),(T)(sin(angle)));
	}
	static Vector2 AngleToVector2(T angle){
		return Vector2<T>::GetVector((T)(cos(angle)),(T)(sin(angle)));
	}

	/*--------------------------------
		
	--------------------------------*/
	void Expand(T length){
		Former();
		fX*=length;
		fY*=length;
	}

	/*--------------------------------
	//	ƑƂ̋瓖ǂ𔻒
	--------------------------------*/
	bool IsHitDistance(Vector2<T> v,T limit);
	static bool IsHitDistance2(Vector2 v1,Vector2 v2,T limit);

	/*--------------------------------
		//ق̃xNg}`Iɂ
	--------------------------------*/
	//gȂȂ邱Ƃ
	void AddVector(Vector2<T> vector){
		fX+=vector.fX;
		fY+=vector.fY;
	}

	/*--------------------------------
	//	2̍̕xNg擾
	--------------------------------*/
	static Vector2 GetTarget2(Vector2<T> v1,Vector2<T> v2){
	  T dx=v1.fX-v2.fX;
	  T dy=v1.fY-v2.fY;
	  Vector2<T> dis=Vector2<T>(dx,dy);
	  return dis;
	}
	

	/*--------------------------------
		NɒB
	--------------------------------*/
	int ChangeDirectionN(int n){
		//O`FbN
		if(n<=0)return -1;

		const T angle=VectorToAngle();
		const T step_deg=360.f/n,delta_deg=step_deg/2.f;

		int dest=0;

		if(angle<=DegreeToRadian(delta_deg) || angle>DegreeToRadian(360-delta_deg)){
			dest=0;
		}else {
			for(int i=1;i<n;i++){
				if(DegreeToRadian(i*step_deg-delta_deg)<angle &&
					DegreeToRadian(i*step_deg+delta_deg)>angle){
					dest=i;
				}
			}
		}
		return dest;

	}
	static int ChangeDirectionN(Vector2<T> v,int n);

	/*--------------------------------
		z[~O֐
	--------------------------------*/
    void GraduateHomingTarget(Vector2<T> target,T turn_speed,Vector2<T> home){
		GraduateHomingAim(Vector2<T>::GetAim(target,home),turn_speed);
	}
    void GraduateHomingAim(Vector2<T> aim,T turn_speed){
		T dx=(aim.fX<0)?-1.f:1.f;
		T dy=(aim.fY<0)?-1.f:1.f;
		Vector2<T> v=Vector2<T>(dx,dy);
		v.Expand(turn_speed);//Gւ̕
		AddVector(v);
	}

    void DirectHomingTarget(Vector2<T> target,Vector2<T> home){
		DirectHomingAim(Vector2<T>::GetAim(target,home));
	}
    void DirectHomingAim(Vector2<T> aim){
		SetVector(aim.fX,aim.fY);
	}
    
    
    /*
    	gڕWւ̕xNgԂ
    */
    Vector2<T> GetAim(Vector2<T> target_pos){
    	Vector2<T> temp=*this;
		temp.SetVector(target_pos.fX-fX,target_pos.fY-fY);
		return temp;
    }
    
    //ʂĂ̐Ê֐͕Kvǂ
    static Vector2<T> GetAim(Vector2<T> target_pos,Vector2<T> home_pos){
    	return home_pos.GetAim(target_pos);
    }
    
};

/*-------------------------------------------------------*/
//	RXgN^
/*-------------------------------------------------------*/
template<class T>Vector2<T>::Vector2(){
	SetVector(0.f,0.f);
}

/*-------------------------------------------------------*/
//	xNg̒lZbg
/*-------------------------------------------------------*/
template<class T>void Vector2<T>::SetVector(T x,T y){
	fX=x;
	fY=y;
}

//O
template<class T>T Vector2<T>::VectorToAngle(Vector2 v){
	return v.VectorToAngle();
}


/**********************
	萔
*********************/
//	̃xNg
static Vector2<float> nullVector2;

#endif
